export default class ContextConfig {
    constructor(ownContextClass, childWidgetClasses) {
        this._ownContextClass = ownContextClass;
        this._childWidgetClasses = childWidgetClasses;
    }
    getContextClasses() {
        const contextClasses = [this._ownContextClass];
        this._childWidgetClasses.forEach((widgetClass) => {
            if (widgetClass.contextConfig) {
                contextClasses.push(widgetClass.contextConfig.getContextClasses());
            }
        });
        // @ts-ignore
        return contextClasses.flat();
    }
}
//# sourceMappingURL=ContextConfig.mjs.map