(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "lodash"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var lodash = require("lodash");
    function undefinedSafeDiffNode(previousProperty, newProperty) {
        if (newProperty) {
            return {
                changed: lodash.isEqual(previousProperty, newProperty),
                value: newProperty
            };
        }
        else {
            return {
                changed: false,
                value: previousProperty
            };
        }
    }
    exports.undefinedSafeDiffNode = undefinedSafeDiffNode;
    function applyMixins(derivedCtor, baseCtors) {
        baseCtors.forEach(function (baseCtor) {
            Object.getOwnPropertyNames(baseCtor.prototype).forEach(function (name) {
                derivedCtor.prototype[name] = baseCtor.prototype[name];
            });
        });
    }
    exports.applyMixins = applyMixins;
});
//# sourceMappingURL=functions.js.map