import { Container } from '@dojo/framework/widget-core/Container';
import { Cell } from '../../gridWidgets/grid/widgets/Cell';
function getValueFromGridContext(context, rowIndex, columnIndex) {
    const rows = context.rowRows.rows;
    const row = rows[rowIndex];
    return String(row.cells[columnIndex].value);
}
function getProperties(inject, properties) {
    const { rowIndex, columnIndex, key } = properties;
    const value = getValueFromGridContext(inject, rowIndex, columnIndex);
    const { isEditable, minWidth } = inject.rowFields.fieldsInfo[columnIndex];
    return {
        value,
        rowIndex,
        columnIndex,
        key,
        isEditable,
        minWidth
    };
}
const CellContainer = Container(Cell, 'gridContext', { getProperties });
export default CellContainer;
//# sourceMappingURL=CellContainer.mjs.map