import { Container } from '@dojo/framework/widget-core/Container';
import CellEditor from '../../gridWidgets/grid/widgets/editors/CellEditor';
function getValueFromGridContext(context, rowIndex, columnIndex) {
    const rows = context.rowRows.rows;
    const row = rows[rowIndex];
    return String(row.cells[columnIndex].value);
}
function getProperties(inject, properties) {
    const { rowIndex, columnIndex, key } = properties;
    const value = getValueFromGridContext(inject, rowIndex, columnIndex);
    const onCellValueUpdate = inject.changeCellValue.bind(inject);
    const { onStopEditing } = properties;
    return {
        value,
        rowIndex,
        columnIndex,
        key,
        onCellValueUpdate,
        onStopEditing
    };
}
const CellEditorContainer = Container(CellEditor, 'gridContext', { getProperties });
export default CellEditorContainer;
//# sourceMappingURL=CellEditorContainer.mjs.map