(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "../../gridWidgets/grid/widgets/Grid", "../../common/MultiContextContainer"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var Grid_1 = require("../../gridWidgets/grid/widgets/Grid");
    var MultiContextContainer_1 = require("../../common/MultiContextContainer");
    function getPropertiesFromGridContext(inject, properties) {
        return {
            context: inject,
        };
    }
    function getPropertiesFromAppContext(inject, properties) {
        var datastoreData = inject.datastoreData, datastoreDataLoadingStatus = inject.datastoreDataLoadingStatus, changeCellValue = inject.changeCellValue;
        var rowRows = {
            rows: datastoreData.map(function (item, index) {
                return {
                    id: item.id || inject.idArray[index],
                    cells: Object.values(item).map(function (value) {
                        return {
                            value: value
                        };
                    })
                };
            })
        };
        var fieldsConfig = inject.fieldsConfig;
        var rowFields = {
            fieldsInfo: datastoreData[0]
                ? Object.keys(datastoreData[0]).map(function (fieldName, index) {
                    var configForField = fieldsConfig.find(function (value) { return value.name === fieldName; });
                    var finalFieldInfo = {
                        name: fieldName,
                        isEditable: true
                    };
                    if (configForField) {
                        finalFieldInfo = tslib_1.__assign({}, finalFieldInfo, configForField);
                    }
                    return finalFieldInfo;
                })
                : []
        };
        return {
            fields: rowFields,
            rows: rowRows,
            loadingStatus: datastoreDataLoadingStatus,
            changeCellValue: changeCellValue.bind(inject)
        };
    }
    var GridContainer = MultiContextContainer_1.default(Grid_1.Grid, {
        'gridContext': getPropertiesFromGridContext,
        'queryAppContext': getPropertiesFromAppContext
    });
    exports.default = GridContainer;
});
//# sourceMappingURL=GridContainer.js.map