import { Grid } from '../../gridWidgets/grid/widgets/Grid';
import MultiContextContainer from '../../common/MultiContextContainer';
function getPropertiesFromGridContext(inject, properties) {
    return {
        context: inject,
    };
}
function getPropertiesFromAppContext(inject, properties) {
    const { datastoreData, datastoreDataLoadingStatus, changeCellValue } = inject;
    const rowRows = {
        rows: datastoreData.map((item, index) => {
            return {
                id: item.id || inject.idArray[index],
                cells: Object.values(item).map((value) => {
                    return {
                        value
                    };
                })
            };
        })
    };
    const fieldsConfig = inject.fieldsConfig;
    const rowFields = {
        fieldsInfo: datastoreData[0]
            ? Object.keys(datastoreData[0]).map((fieldName, index) => {
                const configForField = fieldsConfig.find((value) => value.name === fieldName);
                let finalFieldInfo = {
                    name: fieldName,
                    isEditable: true
                };
                if (configForField) {
                    finalFieldInfo = Object.assign({}, finalFieldInfo, configForField);
                }
                return finalFieldInfo;
            })
            : []
    };
    return {
        fields: rowFields,
        rows: rowRows,
        loadingStatus: datastoreDataLoadingStatus,
        changeCellValue: changeCellValue.bind(inject)
    };
}
const GridContainer = MultiContextContainer(Grid, {
    'gridContext': getPropertiesFromGridContext,
    'queryAppContext': getPropertiesFromAppContext
});
export default GridContainer;
//# sourceMappingURL=GridContainer.mjs.map