(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "@dojo/framework/widget-core/Container", "../../gridWidgets/paginator/Paginator"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var Container_1 = require("@dojo/framework/widget-core/Container");
    var Paginator_1 = require("../../gridWidgets/paginator/Paginator");
    function getProperties(inject, properties) {
        var currentCount = inject.datastoreData.length;
        var loadingStatus = inject.datastoreDataLoadingStatus;
        var totalCount = inject.countData;
        var pageSizeOptions = ['20', '50', '100', '200', '500', '1000', '5000', '100000'];
        return {
            loadingStatus: loadingStatus,
            pageSizeOptions: pageSizeOptions,
            currentCount: currentCount,
            totalCount: totalCount,
            setLimitNode: inject.setQueryLimit.bind(inject)
        };
    }
    var PaginatorContainer = Container_1.Container(Paginator_1.default, 'queryAppContext', { getProperties: getProperties });
    exports.default = PaginatorContainer;
});
//# sourceMappingURL=PaginatorContainer.js.map