(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "@dojo/framework/widget-core/Container", "../../gridWidgets/grid/widgets/row/Row"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var Container_1 = require("@dojo/framework/widget-core/Container");
    var Row_1 = require("../../gridWidgets/grid/widgets/row/Row");
    function getProperties(inject, properties) {
        var rowIndex = properties.rowIndex, key = properties.key;
        var rowFields = inject.rowFields;
        var onSelect = function () {
            inject.selectRow(rowIndex);
        };
        var isSelected = rowIndex === inject.selectedRowIndex;
        return {
            rowFields: rowFields,
            rowIndex: rowIndex,
            key: key,
            onSelect: onSelect,
            isSelected: isSelected
        };
    }
    var RowContainer = Container_1.default(Row_1.Row, 'gridContext', { getProperties: getProperties });
    exports.default = RowContainer;
});
//# sourceMappingURL=RowContainer.js.map