(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "@dojo/framework/widget-core/Container", "../../gridWidgets/searchBar/SearchBar"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var Container_1 = require("@dojo/framework/widget-core/Container");
    var SearchBar_1 = require("../../gridWidgets/searchBar/SearchBar");
    function getProperties(inject, properties) {
        var loadingStatus = inject.datastoreDataLoadingStatus;
        var rowFields = {
            fieldsInfo: inject.datastoreData[0]
                ? Object.keys(inject.datastoreData[0]).map(function (key) {
                    return {
                        name: key
                    };
                })
                : []
        };
        return {
            rowFields: rowFields,
            loadingStatus: loadingStatus,
            setFilterNode: inject.setQueryQuery.bind(inject),
            cancelSearch: inject.removeQueryQuery.bind(inject)
        };
    }
    var SearchBarContainer = Container_1.Container(SearchBar_1.default, 'queryAppContext', { getProperties: getProperties });
    exports.default = SearchBarContainer;
});
//# sourceMappingURL=SearchBarContainer.js.map