(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "@dojo/framework/widget-core/Container", "../../context/QueryEditorContext", "../../queryEditor/queryQueryEditor/logicalEditor/ChildNodeCreationFormDialog"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var Container_1 = require("@dojo/framework/widget-core/Container");
    var QueryEditorContext_1 = require("../../context/QueryEditorContext");
    var ChildNodeCreationFormDialog_1 = require("../../queryEditor/queryQueryEditor/logicalEditor/ChildNodeCreationFormDialog");
    function getProperties(inject, properties) {
        var onChildNodeCreate = properties.onChildNodeCreate;
        var fieldNames = inject.fieldNames;
        var isOpen = inject.dialogs.get(QueryEditorContext_1.QueryEditorDialogNames.addNewNodeDialog).shown;
        var closeDialog = function () { inject.dialogs.hide(QueryEditorContext_1.QueryEditorDialogNames.addNewNodeDialog); };
        return {
            isOpen: isOpen,
            closeDialog: closeDialog,
            onChildNodeCreate: onChildNodeCreate,
            fieldNames: fieldNames
        };
    }
    var ChildNodeCreationFormDialogContainer = Container_1.default(ChildNodeCreationFormDialog_1.default, 'queryEditorContext', { getProperties: getProperties });
    exports.default = ChildNodeCreationFormDialogContainer;
});
//# sourceMappingURL=childNodeCreationFormDialogContainer.js.map