import Container from '@dojo/framework/widget-core/Container';
import { QueryEditorDialogNames } from '../../context/QueryEditorContext';
import ChildNodeCreationFormDialog from '../../queryEditor/queryQueryEditor/logicalEditor/ChildNodeCreationFormDialog';
function getProperties(inject, properties) {
    const { onChildNodeCreate } = properties;
    const { fieldNames } = inject;
    const isOpen = inject.dialogs.get(QueryEditorDialogNames.addNewNodeDialog).shown;
    const closeDialog = () => { inject.dialogs.hide(QueryEditorDialogNames.addNewNodeDialog); };
    return {
        isOpen,
        closeDialog,
        onChildNodeCreate,
        fieldNames
    };
}
const ChildNodeCreationFormDialogContainer = Container(ChildNodeCreationFormDialog, 'queryEditorContext', { getProperties });
export default ChildNodeCreationFormDialogContainer;
//# sourceMappingURL=childNodeCreationFormDialogContainer.mjs.map