(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "@dojo/framework/widget-core/Container", "../../context/QueryEditorContext", "../../queryEditor/queryQueryEditor/logicalEditor/LogicalNodeEditor"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var Container_1 = require("@dojo/framework/widget-core/Container");
    var QueryEditorContext_1 = require("../../context/QueryEditorContext");
    var LogicalNodeEditor_1 = require("../../queryEditor/queryQueryEditor/logicalEditor/LogicalNodeEditor");
    function getProperties(inject, properties) {
        var path = properties.path, key = properties.key;
        var node = inject.hasNodeForPath(path)
            ? inject.getNodeForPath(path)
            : null;
        var onRemove = inject.removeNodeForPath.bind(inject);
        var onAddChildNode = function (node, index) {
            if (index === void 0) { index = 0; }
            var finalPath = path.concat([index]);
            inject.addNodeForPath(node, finalPath);
        };
        var fieldNames = inject.fieldNames;
        var openDialog = function () { inject.dialogs.show(QueryEditorContext_1.QueryEditorDialogNames.addNewNodeDialog); };
        return {
            path: path,
            fieldNames: fieldNames,
            node: node,
            onRemove: onRemove,
            onAddChildNode: onAddChildNode,
            key: key,
            openDialog: openDialog
        };
    }
    var LogicalNodeEditorContainer = Container_1.default(LogicalNodeEditor_1.default, 'queryEditorContext', { getProperties: getProperties });
    exports.default = LogicalNodeEditorContainer;
});
//# sourceMappingURL=logicalNodeEditorContainer.js.map