import Container from '@dojo/framework/widget-core/Container';
import { QueryEditorDialogNames } from '../../context/QueryEditorContext';
import LogicalNodeEditor from '../../queryEditor/queryQueryEditor/logicalEditor/LogicalNodeEditor';
function getProperties(inject, properties) {
    const { path, key } = properties;
    const node = inject.hasNodeForPath(path)
        ? inject.getNodeForPath(path)
        : null;
    const onRemove = inject.removeNodeForPath.bind(inject);
    const onAddChildNode = (node, index = 0) => {
        const finalPath = path.concat([index]);
        inject.addNodeForPath(node, finalPath);
    };
    const fieldNames = inject.fieldNames;
    const openDialog = () => { inject.dialogs.show(QueryEditorDialogNames.addNewNodeDialog); };
    return {
        path,
        fieldNames,
        node,
        onRemove,
        onAddChildNode,
        key,
        openDialog
    };
}
const LogicalNodeEditorContainer = Container(LogicalNodeEditor, 'queryEditorContext', { getProperties });
export default LogicalNodeEditorContainer;
//# sourceMappingURL=logicalNodeEditorContainer.mjs.map