(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "@dojo/framework/widget-core/Container", "../../queryEditor/queryQueryEditor/scalarNodeEditor/ScalarNodeEditor"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var Container_1 = require("@dojo/framework/widget-core/Container");
    var ScalarNodeEditor_1 = require("../../queryEditor/queryQueryEditor/scalarNodeEditor/ScalarNodeEditor");
    function getProperties(inject, properties) {
        var path = properties.path, key = properties.key;
        var node = inject.hasNodeForPath(path)
            ? inject.getNodeForPath(path)
            : null;
        var onRemove = inject.removeNodeForPath.bind(inject);
        var fieldNames = inject.fieldNames;
        return {
            path: path,
            fieldNames: fieldNames,
            node: node,
            onRemove: onRemove,
            key: key
        };
    }
    var ScalarNodeEditorContainer = Container_1.default(ScalarNodeEditor_1.default, 'queryEditorContext', { getProperties: getProperties });
    exports.default = ScalarNodeEditorContainer;
});
//# sourceMappingURL=scalarNodeEditorContainer.js.map