(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "@dojo/framework/widget-core/Container", "../../context/QueryEditorContext", "../../queryEditor/sortNodeEditor/SortNodeEditor", "rollun-ts-rql/dist/nodes/Sort"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var Container_1 = require("@dojo/framework/widget-core/Container");
    var QueryEditorContext_1 = require("../../context/QueryEditorContext");
    var SortNodeEditor_1 = require("../../queryEditor/sortNodeEditor/SortNodeEditor");
    var Sort_1 = require("rollun-ts-rql/dist/nodes/Sort");
    function getProperties(inject, properties) {
        return {
            node: inject.query.sortNode,
            onRemove: function () { inject.removeNode(QueryEditorContext_1.QueryNodeNames.sort); },
            onSortNodeChange: function (sortOptions) {
                inject.setSortNode(new Sort_1.default(sortOptions));
            }
        };
    }
    var SortNodeEditorContainer = Container_1.default(SortNodeEditor_1.default, 'queryEditorContext', { getProperties: getProperties });
    exports.default = SortNodeEditorContainer;
});
//# sourceMappingURL=sortNodeEditorContainer.js.map