(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var GridContext = /** @class */ (function () {
        function GridContext(invalidator, initialState) {
            this._invalidator = invalidator;
            if (initialState.fields) {
                this._rowFields = initialState.fields;
            }
            if (initialState.rows) {
                this._rowRows = initialState.rows;
            }
        }
        Object.defineProperty(GridContext.prototype, "rowFields", {
            get: function () {
                return this._rowFields;
            },
            set: function (fields) {
                this._rowFields = fields;
                this._invalidator();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GridContext.prototype, "rowRows", {
            get: function () {
                return this._rowRows;
            },
            set: function (rows) {
                this._rowRows = rows;
                this._invalidator();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GridContext.prototype, "changeDataItem", {
            set: function (value) {
                this._changeDataItem = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GridContext.prototype, "selectedRowIndex", {
            get: function () {
                return this._selectedRowIndex;
            },
            enumerable: true,
            configurable: true
        });
        GridContext.prototype.changeCellValue = function (rowIndex, columnIndex, value) {
            this._changeDataItem(rowIndex, columnIndex, value);
        };
        GridContext.prototype.selectRow = function (index) {
            this._selectedRowIndex = index;
            this._invalidator();
        };
        return GridContext;
    }());
    exports.default = GridContext;
});
//# sourceMappingURL=GridContext.js.map