(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../../common/interfaces"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var interfaces_1 = require("../../common/interfaces");
    var AbstractDataUpdater = /** @class */ (function () {
        function AbstractDataUpdater() {
        }
        Object.defineProperty(AbstractDataUpdater.prototype, "loadingStatus", {
            get: function () {
                return this._loadingStatus;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractDataUpdater.prototype, "data", {
            get: function () {
                return this._data;
            },
            enumerable: true,
            configurable: true
        });
        AbstractDataUpdater.prototype.updateData = function () {
            var _this = this;
            this._loadingStatus = interfaces_1.LoadingStatusEnum.loading;
            return new Promise(function (resolve, reject) {
                _this._updateData().then(function (data) {
                    _this._data = _this.afterProcess(data);
                    _this._loadingStatus = interfaces_1.LoadingStatusEnum.loaded;
                    resolve();
                }, function (error) {
                    _this._loadingStatus = interfaces_1.LoadingStatusEnum.error;
                    reject(error);
                });
            });
        };
        AbstractDataUpdater.prototype.afterProcess = function (data) {
            return data;
        };
        return AbstractDataUpdater;
    }());
    exports.default = AbstractDataUpdater;
});
//# sourceMappingURL=AbstractDataUpdater.js.map