(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "rollun-ts-rql/dist/Query", "./AbstractDatastoreDataUpdater", "rollun-ts-rql/dist/nodes/Select", "rollun-ts-rql/dist/nodes/aggregateNodes/AggregateFunctionNode"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var Query_1 = require("rollun-ts-rql/dist/Query");
    var AbstractDatastoreDataUpdater_1 = require("./AbstractDatastoreDataUpdater");
    var Select_1 = require("rollun-ts-rql/dist/nodes/Select");
    var AggregateFunctionNode_1 = require("rollun-ts-rql/dist/nodes/aggregateNodes/AggregateFunctionNode");
    var DatastoreCountUpdater = /** @class */ (function (_super) {
        tslib_1.__extends(DatastoreCountUpdater, _super);
        function DatastoreCountUpdater() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._data = 0;
            return _this;
        }
        DatastoreCountUpdater.prototype.getProcessedQuery = function () {
            var oldQuery = this._queryManager.getQuery();
            return new Query_1.default({
                select: oldQuery.selectNode
                    ? new Select_1.default(tslib_1.__spread(oldQuery.selectNode.fields, [
                        new AggregateFunctionNode_1.default('count', 'id')
                    ]))
                    : new Select_1.default([
                        new AggregateFunctionNode_1.default('count', 'id')
                    ])
            });
        };
        DatastoreCountUpdater.prototype.afterProcess = function (data) {
            return data[0]['count(id)'];
        };
        return DatastoreCountUpdater;
    }(AbstractDatastoreDataUpdater_1.default));
    exports.default = DatastoreCountUpdater;
});
//# sourceMappingURL=DatastoreCountUpdater.js.map