(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@dojo/framework/widget-core/WidgetBase", "@dojo/framework/widget-core/tsx", "rollun-common/dist/css/bootstrap.m.css"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var WidgetBase_1 = require("@dojo/framework/widget-core/WidgetBase");
    var tsx_1 = require("@dojo/framework/widget-core/tsx");
    var bs = require("rollun-common/dist/css/bootstrap.m.css");
    var CsvDownloader = /** @class */ (function (_super) {
        tslib_1.__extends(CsvDownloader, _super);
        function CsvDownloader() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        CsvDownloader.prototype.render = function () {
            var _this = this;
            return (tsx_1.tsx("button", { class: bs.btn + " " + bs.btnPrimary + " " + bs.btnSm, onclick: function () {
                    _this.downloadCsv();
                } }, this.properties.title || 'Download table'));
        };
        CsvDownloader.prototype.downloadCsv = function () {
            var csvContent = 'data:text/csv;charset=utf-8,' + this.getDataInCsv();
            var encodedUri = encodeURI(csvContent);
            var link = document.createElement('a');
            link.setAttribute('href', encodedUri);
            link.setAttribute('download', this.properties.fileName || 'data.csv');
            link.target = '_blank';
            link.style.display = 'none';
            document.body.appendChild(link);
            link.click();
        };
        CsvDownloader.prototype.getDataInCsv = function () {
            var data = this.properties.data.map(function (dataRecord, index) {
                return Object.values(dataRecord);
            });
            var dataString = data.map(function (row) { return row.join(','); }).join('\n');
            var columnHeadersString = Object.keys(this.properties.data[0]).join(',');
            return columnHeadersString + "\n" + dataString;
        };
        return CsvDownloader;
    }(WidgetBase_1.default));
    exports.default = CsvDownloader;
});
//# sourceMappingURL=CsvDownloader.js.map