(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@dojo/framework/widget-core/WidgetBase", "@dojo/framework/widget-core/d", "rollun-common/dist/css/bootstrap.m.css"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var WidgetBase_1 = require("@dojo/framework/widget-core/WidgetBase");
    var d_1 = require("@dojo/framework/widget-core/d");
    var bs = require("rollun-common/dist/css/bootstrap.m.css");
    var Dialog = /** @class */ (function (_super) {
        tslib_1.__extends(Dialog, _super);
        function Dialog() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Dialog.prototype.render = function () {
            var _this = this;
            var title = this.properties.title;
            var onOk = this.properties.onOk
                ? function (event) {
                    // @ts-ignore
                    _this.properties.onOk();
                }
                : function (event) {
                };
            var onClose = this.properties.onClose;
            var modalSizeClass = this.getModalSize();
            var centered = (this.properties.options && this.properties.options.centered);
            return this.properties.isOpen
                ? [
                    d_1.v('div', {
                        classes: bs.modal + " " + bs.fade + " " + bs.show + " " + bs.dBlock,
                        tabIndex: -1,
                        role: 'dialog',
                    }, [
                        d_1.v('div', {
                            classes: bs.modalDialog + " " + modalSizeClass + " " + (centered ? bs.modalDialogCentered : ''),
                            role: 'document',
                        }, [
                            d_1.v('div', { classes: bs.modalContent }, [
                                d_1.v('div', { classes: bs.modalHeader }, [
                                    d_1.v('h5', { classes: bs.modalTitle }, [
                                        title
                                    ]),
                                    d_1.v('button', {
                                        classes: bs.close,
                                        onclick: onClose
                                    }, [
                                        d_1.v('span', { ariaHidden: true }, [
                                            '×'
                                        ])
                                    ])
                                ]),
                                d_1.v('div', { classes: bs.modalBody }, this.children),
                                d_1.v('div', { classes: bs.modalFooter + " " + (this.properties.onOk ? '' : bs.dNone) }, [
                                    d_1.v('button', {
                                        classes: bs.btn + " " + bs.btnPrimary + " " + bs.btnSm + " ",
                                        onclick: onOk
                                    }, ['OK'])
                                ])
                            ])
                        ])
                    ]),
                    d_1.v('div', { classes: bs.show + " " + bs.modalBackdrop }),
                ]
                : null;
        };
        Dialog.prototype.getModalSize = function () {
            var classMap = [bs.modalSm, '', bs.modalLg, bs.modalXl];
            var sizeFlag = this.properties.options ? this.properties.options.size : 2;
            // @ts-ignore
            return classMap[(sizeFlag - 1)];
        };
        return Dialog;
    }(WidgetBase_1.default));
    exports.default = Dialog;
});
//# sourceMappingURL=Dialog.js.map