(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@dojo/framework/widget-core/WidgetBase", "@dojo/framework/widget-core/d", "rollun-common/dist/css/bootstrap.m.css", "../../../containers/grid/CellEditorContainer"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var WidgetBase_1 = require("@dojo/framework/widget-core/WidgetBase");
    var d_1 = require("@dojo/framework/widget-core/d");
    var bootstrap = require("rollun-common/dist/css/bootstrap.m.css");
    var CellEditorContainer_1 = require("../../../containers/grid/CellEditorContainer");
    var Cell = /** @class */ (function (_super) {
        tslib_1.__extends(Cell, _super);
        function Cell() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Cell.prototype.render = function () {
            return d_1.v('td', this.getCellNodeProperties(), [
                this.getValue()
            ]);
        };
        Cell.prototype.getCellNodeProperties = function () {
            var _this = this;
            var cellNodeProps = {
                classes: bootstrap.p1 + " " + bootstrap.alignItemsCenter + " " + bootstrap.borderLeft,
                styles: {
                    minWidth: '100px'
                }
            };
            if (this.properties.minWidth) {
                cellNodeProps.styles.minWidth = this.properties.minWidth + 'px';
            }
            if (this.properties.isEditable) {
                cellNodeProps.ondblclick = function () {
                    _this.isEdited = true;
                    _this.invalidate();
                };
            }
            return cellNodeProps;
        };
        Cell.prototype.getValue = function () {
            var _this = this;
            if (this.isEdited) {
                var _a = this.properties, rowIndex = _a.rowIndex, columnIndex = _a.columnIndex;
                var onStopEditing = function () {
                    _this.isEdited = false;
                    _this.invalidate();
                };
                return d_1.w(CellEditorContainer_1.default, { rowIndex: rowIndex, columnIndex: columnIndex, onStopEditing: onStopEditing });
            }
            else {
                return this.properties.value;
            }
        };
        return Cell;
    }(WidgetBase_1.default));
    exports.Cell = Cell;
});
//# sourceMappingURL=Cell.js.map