(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@dojo/framework/widget-core/WidgetBase", "@dojo/framework/widget-core/d", "rollun-ts-rql/dist/nodes/Limit", "rollun-common/dist/css/bootstrap.m.css", "rollun-common/dist/css/fontawesome.m.css", "rollun-common/dist/css/solid.m.css", "./paginator.m.css", "../../common/interfaces"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var WidgetBase_1 = require("@dojo/framework/widget-core/WidgetBase");
    var d_1 = require("@dojo/framework/widget-core/d");
    var Limit_1 = require("rollun-ts-rql/dist/nodes/Limit");
    var bootstrap = require("rollun-common/dist/css/bootstrap.m.css");
    var fa = require("rollun-common/dist/css/fontawesome.m.css");
    var faSolid = require("rollun-common/dist/css/solid.m.css");
    var ownCss = require("./paginator.m.css");
    var interfaces_1 = require("../../common/interfaces");
    var Paginator = /** @class */ (function (_super) {
        tslib_1.__extends(Paginator, _super);
        function Paginator() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.currentPageSize = '20';
            _this.pageNumber = 1;
            return _this;
        }
        Paginator.prototype.render = function () {
            var _this = this;
            var isLoading = this.properties.loadingStatus === interfaces_1.LoadingStatusEnum.loading;
            var rootNodeClasses = bootstrap.dFlex + " " + bootstrap.flexRow + " " + bootstrap.alignItemsCenter + " " + bootstrap.p1;
            if (isLoading) {
                rootNodeClasses += ownCss.loading;
            }
            return d_1.v('div', { classes: rootNodeClasses }, [
                d_1.v('div', { classes: bootstrap.dFlex + " " + bootstrap.flexRow + " " + bootstrap.alignItemsCenter + " " }, [
                    d_1.v('div', { classes: bootstrap.dFlex + " " + bootstrap.flexRow + " " + bootstrap.alignItemsCenter + "  " + bootstrap.mr4 + " " }, [
                        d_1.v('button', {
                            disabled: isLoading,
                            classes: bootstrap.btn + "  " + bootstrap.btnSm + " " + bootstrap.btnLight + " " + bootstrap.border + "  " + bootstrap.mx1,
                            onclick: function () {
                                _this.goToPage(_this.pageNumber - 1);
                            }
                        }, [
                            d_1.v('i', { classes: faSolid.fas + " " + fa.faArrowLeft + " " })
                        ]),
                        d_1.v('div', {
                            classes: bootstrap.px1 + "  " + bootstrap.mx1
                        }, [" " + this.pageNumber + " "]),
                        d_1.v('button', {
                            disabled: isLoading,
                            classes: bootstrap.btn + "  " + bootstrap.btnSm + " " + bootstrap.btnLight + " " + bootstrap.border + "  " + bootstrap.mx1,
                            onclick: function () {
                                _this.goToPage(_this.pageNumber + 1);
                            }
                        }, [
                            d_1.v('i', { classes: faSolid.fas + " " + fa.faArrowRight + " " })
                        ])
                    ]),
                    d_1.v('div', { classes: bootstrap.dFlex + " " + bootstrap.flexRow + " " + bootstrap.alignItemsCenter + "  " + bootstrap.mr4 + " " }, [
                        d_1.v('div', {
                            classes: bootstrap.mx1 + " " + ownCss.pageSizeLabel,
                        }, ['Page size']),
                        d_1.v('select', {
                            disabled: isLoading,
                            classes: "" + bootstrap.customSelect,
                            onchange: function (event) {
                                // @ts-ignore
                                _this.changePageSize(event.target.value);
                            }
                        }, this.properties.pageSizeOptions.map(function (pageSize) { return d_1.v('option', { value: pageSize }, [pageSize]); }))
                    ])
                ]),
                d_1.v('div', { classes: bootstrap.dFlex + " " + bootstrap.flexRow + " " + bootstrap.alignItemsCenter + "  " + bootstrap.mx1 }, [
                    this.getInfo()
                ])
            ]);
        };
        Paginator.prototype.goToPage = function (pageNumber) {
            var currentPageSize = parseInt(this.currentPageSize, 10);
            if (pageNumber < 1 || pageNumber > Math.ceil(this.properties.totalCount / currentPageSize)) {
                return;
            }
            this.pageNumber = pageNumber;
            var offset = currentPageSize * (this.pageNumber - 1);
            this.properties.setLimitNode(new Limit_1.default(currentPageSize, offset));
            this.invalidate();
        };
        Paginator.prototype.changePageSize = function (pageSize) {
            this.currentPageSize = pageSize;
            this.goToPage(1);
        };
        Paginator.prototype.getInfo = function () {
            var _a = this.properties, currentCount = _a.currentCount, totalCount = _a.totalCount;
            var currentPageSize = parseInt(this.currentPageSize, 10);
            var startItemNumber = currentPageSize * (this.pageNumber - 1) + 1; // FIXME: wrong item count when grid is showing 'No data'
            var endItemNumber = startItemNumber + currentCount - 1;
            return "Showing items " + startItemNumber + "-" + endItemNumber + " of " + totalCount;
        };
        return Paginator;
    }(WidgetBase_1.default));
    exports.default = Paginator;
});
//# sourceMappingURL=Paginator.js.map