import WidgetBase from '@dojo/framework/widget-core/WidgetBase';
import QueryEditorContainerModalContainer from '../containers/queryBuilder/queryEditorContainerModalContainer';
import GridContainer from '../containers/grid/GridContainer';
import SearchBarContainer from '../containers/grid/SearchBarContainer';
import PaginatorContainer from '../containers/grid/PaginatorContainer';
import * as bs from 'rollun-common/dist/css/bootstrap.m.css';
import ContextConfig from '../common/ContextConfig';
import QueryAppContext from '../context/QueryAppContext';
import { Grid } from '../gridWidgets/grid/widgets/Grid';
import QueryEditor from '../queryEditor';
import { tsx } from '@dojo/framework/widget-core/tsx';
import CsvDownloaderContainer from '../containers/CsvDownloaderContainer';
import RowEditorDialogContainer from '../containers/RowEditorDialogContainer';
import NewItemCreatorDialogContainer from '../containers/NewItemCreatorDialogContainer';
export default class QueryAppWidget extends WidgetBase {
    render() {
        return (tsx("div", { id: 'gridContainer' },
            tsx("div", { class: `${bs.dFlex} ${bs.bgLight} ${bs.px1} ${bs.py2} ${bs.border} ${bs.borderBottom0}` },
                tsx("div", { class: `${bs.dFlex} ${bs.flexRow} ${bs.alignItemsCenter}`, styles: { flex: '5' } },
                    tsx("div", { class: `${bs.mx1}` },
                        tsx(QueryEditorContainerModalContainer, null)),
                    tsx("div", { class: `${bs.mx1}` },
                        tsx(CsvDownloaderContainer, null)),
                    tsx("div", { class: `${bs.mx1}` },
                        tsx(RowEditorDialogContainer, null)),
                    tsx("div", { class: `${bs.mx1}` },
                        tsx(NewItemCreatorDialogContainer, null))),
                tsx("div", { class: `${bs.dFlex} ${bs.flexRowReverse}`, styles: { flex: '2' } },
                    tsx(SearchBarContainer, null))),
            tsx(GridContainer, null),
            tsx("div", { class: `${bs.dFlex} ${bs.w100} ${bs.p1} ${bs.bgLight} ${bs.border} ${bs.borderTop0}` },
                tsx(PaginatorContainer, null))));
    }
}
QueryAppWidget.contextConfig = new ContextConfig(QueryAppContext, [Grid, QueryEditor]);
//# sourceMappingURL=QueryAppWidget.mjs.map