(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@dojo/framework/widget-core/WidgetBase", "@dojo/framework/widget-core/d", "./dropToRemoveField.m.css", "rollun-common/dist/css/bootstrap.m.css", "rollun-common/dist/css/fontawesome.m.css", "rollun-common/dist/css/solid.m.css", "../common/common.m.css", "../../context/QueryEditorContext"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var WidgetBase_1 = require("@dojo/framework/widget-core/WidgetBase");
    var d_1 = require("@dojo/framework/widget-core/d");
    var css = require("./dropToRemoveField.m.css");
    var bs = require("rollun-common/dist/css/bootstrap.m.css");
    var fa = require("rollun-common/dist/css/fontawesome.m.css");
    var faSolid = require("rollun-common/dist/css/solid.m.css");
    var commonCss = require("../common/common.m.css");
    var QueryEditorContext_1 = require("../../context/QueryEditorContext");
    var DropToRemoveNodeField = /** @class */ (function (_super) {
        tslib_1.__extends(DropToRemoveNodeField, _super);
        function DropToRemoveNodeField() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.awaitingDrop = false;
            _this.validDropTarget = false;
            return _this;
        }
        DropToRemoveNodeField.prototype.render = function () {
            var _this = this;
            var classes = css.root + " " + bs.card + " " + bs.h100 + " " + bs.m1 + " " + commonCss.transparentBorder;
            if (this.awaitingDrop === true) {
                classes += this.validDropTarget ? " " + commonCss.validBorder : " " + commonCss.invalidBorder;
            }
            return d_1.v('div', {
                classes: classes,
                ondragover: function (event) {
                    _this.checkDropPossibility(event);
                },
                ondragleave: function (event) {
                    _this.disableDropTarget(event);
                },
                ondrop: function (event) {
                    _this.removeDroppedNodeFromSelectedNodes(event);
                    _this.disableDropTarget(event);
                }
            }, [
                d_1.v('div', { classes: bs.cardBody + " " + bs.p3 + " " + bs.h100 + " " + bs.border }, [
                    d_1.v('span', { classes: css.title + " " + bs.cardTitle }, ['Drop field to remove it']),
                    d_1.v('div', { classes: bs.cardText + " " + bs.dFlex + " " + bs.justifyContentCenter + " " + bs.alignItemsCenter + " " + css.iconAligner }, [
                        d_1.v('div', {}, [
                            d_1.v('i', { classes: faSolid.fas + " " + fa.faTrashAlt + " " + fa.fa3x })
                        ])
                    ])
                ])
            ]);
        };
        DropToRemoveNodeField.prototype.checkDropPossibility = function (event) {
            event.preventDefault();
            if (event.dataTransfer.types.indexOf('nodefieldname') !== -1) {
                this.awaitingDrop = true;
                this.validDropTarget = true;
                this.invalidate();
                return false;
            }
            this.invalidate();
            return true;
        };
        DropToRemoveNodeField.prototype.disableDropTarget = function (event) {
            this.awaitingDrop = false;
            this.validDropTarget = false;
            this.invalidate();
        };
        DropToRemoveNodeField.prototype.removeDroppedNodeFromSelectedNodes = function (event) {
            var nodeFieldName = event.dataTransfer.getData('nodefieldname');
            var nodeType;
            if (event.dataTransfer.types.indexOf('selectnode') !== -1) {
                nodeType = QueryEditorContext_1.QueryNodeNames.select;
            }
            else {
                nodeType = QueryEditorContext_1.QueryNodeNames.sort;
            }
            this.properties.onNodeFieldRemove(nodeFieldName, nodeType);
        };
        return DropToRemoveNodeField;
    }(WidgetBase_1.default));
    exports.default = DropToRemoveNodeField;
});
//# sourceMappingURL=DropToRemoveNodeField.js.map