(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@dojo/framework/widget-core/WidgetBase", "@dojo/framework/widget-core/d", "./nodeFieldName.m.css", "rollun-common/dist/css/bootstrap.m.css", "rollun-ts-rql/dist/nodes/aggregateNodes/AggregateFunctionNode", "../../common/common.m.css"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var WidgetBase_1 = require("@dojo/framework/widget-core/WidgetBase");
    var d_1 = require("@dojo/framework/widget-core/d");
    var css = require("./nodeFieldName.m.css");
    var bs = require("rollun-common/dist/css/bootstrap.m.css");
    var AggregateFunctionNode_1 = require("rollun-ts-rql/dist/nodes/aggregateNodes/AggregateFunctionNode");
    var commonCss = require("../../common/common.m.css");
    var NodeFieldName = /** @class */ (function (_super) {
        tslib_1.__extends(NodeFieldName, _super);
        function NodeFieldName() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        NodeFieldName.prototype.render = function () {
            var _this = this;
            var classes = bs.py1 + " " + bs.px2 + " " + bs.mb1 + " " + css.root + " " + commonCss.headerCellFont;
            if (this.properties.isActive) {
                classes += " " + css.active;
            }
            return d_1.v('div', {
                draggable: true,
                ondragstart: function (event) {
                    _this.handleDragStart(event);
                },
                classes: classes
            }, ["" + this.properties.fieldName]);
        };
        NodeFieldName.prototype.handleDragStart = function (event) {
            var nodeFieldName = this.properties.fieldName instanceof AggregateFunctionNode_1.default
                ? this.properties.fieldName.function + "(" + this.properties.fieldName.field + ")"
                : this.properties.fieldName;
            event.dataTransfer.setData('nodefieldname', nodeFieldName);
            if (this.properties.nodeType) {
                event.dataTransfer.setData(this.properties.nodeType, '');
            }
        };
        return NodeFieldName;
    }(WidgetBase_1.default));
    exports.default = NodeFieldName;
});
//# sourceMappingURL=NodeFieldName.js.map