(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@dojo/framework/widget-core/WidgetBase", "@dojo/framework/widget-core/d", "./arrayNode.m.css", "rollun-common/dist/css/bootstrap.m.css", "rollun-common/dist/css/fontawesome.m.css", "rollun-common/dist/css/solid.m.css", "@dojo/framework/widget-core/decorators/diffProperty", "../../../common/functions"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var WidgetBase_1 = require("@dojo/framework/widget-core/WidgetBase");
    var d_1 = require("@dojo/framework/widget-core/d");
    var ownCss = require("./arrayNode.m.css");
    var bs = require("rollun-common/dist/css/bootstrap.m.css");
    var fa = require("rollun-common/dist/css/fontawesome.m.css");
    var faSolid = require("rollun-common/dist/css/solid.m.css");
    var diffProperty_1 = require("@dojo/framework/widget-core/decorators/diffProperty");
    var functions_1 = require("../../../common/functions");
    var ArrayNodeEditor = /** @class */ (function (_super) {
        tslib_1.__extends(ArrayNodeEditor, _super);
        function ArrayNodeEditor() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ArrayNodeEditor.prototype.render = function () {
            var _this = this;
            var nodeValueEditorText = this.properties.node.values.join();
            return d_1.v('div', { classes: bs.dFlex + " " + bs.flexRow + " " + bs.p2 + " " + bs.mb1 + " " + ownCss.root }, [
                d_1.v('div', { classes: bs.dFlex + " " + bs.flexRow + " " + ownCss.controlsContainer }, [
                    d_1.v('select', {
                        classes: bs.customSelect,
                        onChange: function (event) {
                            // @ts-ignore
                            _this.dialogState.array.field = event.target.value;
                        }
                    }, this.properties.fieldNames.map(function (nodeName) { return d_1.v('option', { value: nodeName, selected: nodeName === _this.properties.node.name }, [nodeName]); })),
                    d_1.v('div', { classes: bs.px3 + " " + bs.py1 + " " + bs.dFlex + " " + bs.alignItemsCenter }, [this.getHumanNodeName(this.properties.node.name)]),
                    d_1.v('input', {
                        type: 'text',
                        classes: bs.formControl,
                        value: nodeValueEditorText,
                        onchange: function (event) {
                            // @ts-ignore
                            _this.properties.node.values = event.target.value.split(',');
                            _this.invalidate();
                        }
                    }),
                ]),
                d_1.v('div', { classes: bs.dFlex + " " + bs.flexRowReverse + " " + ownCss.closeBtnContainer }, [
                    d_1.v('button', {
                        classes: ownCss.removeButton + " " + bs.btn + " " + bs.btnDanger,
                        onclick: function () {
                            _this.removeSelf();
                        }
                    }, [
                        d_1.v('i', { classes: faSolid.fas + " " + fa.faTimes })
                    ])
                ]),
            ]);
        };
        ArrayNodeEditor.prototype.removeSelf = function () {
            this.properties.onRemove(this.properties.path);
        };
        ArrayNodeEditor.prototype.getHumanNodeName = function (nodeName) {
            return nodeName;
        };
        tslib_1.__decorate([
            diffProperty_1.default('node', functions_1.undefinedSafeDiffNode),
            tslib_1.__metadata("design:type", Function),
            tslib_1.__metadata("design:paramtypes", []),
            tslib_1.__metadata("design:returntype", Object)
        ], ArrayNodeEditor.prototype, "render", null);
        return ArrayNodeEditor;
    }(WidgetBase_1.default));
    exports.default = ArrayNodeEditor;
});
//# sourceMappingURL=ArrayNodeEditor.js.map