(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@dojo/framework/widget-core/WidgetBase", "@dojo/framework/widget-core/d", "@dojo/widgets/accordion-pane", "@dojo/widgets/title-pane", "rollun-common/dist/css/bootstrap.m.css", "./childNodeCreationForm.m.css"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var WidgetBase_1 = require("@dojo/framework/widget-core/WidgetBase");
    var d_1 = require("@dojo/framework/widget-core/d");
    var accordion_pane_1 = require("@dojo/widgets/accordion-pane");
    var title_pane_1 = require("@dojo/widgets/title-pane");
    var bs = require("rollun-common/dist/css/bootstrap.m.css");
    var ownCss = require("./childNodeCreationForm.m.css");
    var ChildNodeCreationForm = /** @class */ (function (_super) {
        tslib_1.__extends(ChildNodeCreationForm, _super);
        function ChildNodeCreationForm() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.scalarNodeNames = [
                'like',
                'alike',
                'eq',
                'ge',
                'gt',
                'le',
                'lt',
                'ne'
            ];
            _this.arrayNodeNames = [
                'in', 'out'
            ];
            _this.dialogState = {
                scalar: {
                    name: _this.scalarNodeNames[0],
                    field: '',
                    value: ''
                },
                array: {
                    name: _this.arrayNodeNames[0],
                    field: '',
                    value: ''
                }
            };
            return _this;
        }
        ChildNodeCreationForm.prototype.render = function () {
            var _this = this;
            this.dialogState.scalar.field = this.properties.fieldNames[0];
            this.dialogState.array.field = this.properties.fieldNames[0];
            return d_1.w(accordion_pane_1.default, {
                onRequestOpen: function (key) {
                    _this.openKey = key;
                    _this.invalidate();
                },
                onRequestClose: function (key) {
                    _this.openKey = '';
                    _this.invalidate();
                },
                openKeys: [this.openKey]
            }, [
                d_1.w(title_pane_1.default, {
                    extraClasses: {
                        title: '',
                        root: "" + bs.overflowHidden,
                        titleButton: bs.btn + " " + bs.btnLight + " " + bs.w100 + " " + bs.dropdownToggle + " " + bs.positionRelative
                    },
                    title: 'Logical Nodes',
                    key: '1'
                }, [
                    d_1.v('div', { classes: bs.p1 + " " + ownCss.logicalNodes }, [
                        d_1.v('button', {
                            classes: bs.btn + " " + bs.btnSm + " " + bs.btnPrimary + " " + bs.btnBlock,
                            onclick: function () {
                                _this.createChildNode('and', { subNodes: [] });
                            }
                        }, [' AND ']),
                        d_1.v('button', {
                            classes: bs.btn + " " + bs.btnSm + " " + bs.btnPrimary + " " + bs.btnBlock,
                            onclick: function () {
                                _this.createChildNode('or', { subNodes: [] });
                            }
                        }, [' OR '])
                    ])
                ]),
                d_1.w(title_pane_1.default, {
                    extraClasses: {
                        title: '',
                        root: "" + bs.overflowHidden,
                        titleButton: bs.btn + " " + bs.btnLight + " " + bs.w100 + " " + bs.dropdownToggle + " " + bs.positionRelative
                    },
                    title: 'Scalar Nodes',
                    key: '2'
                }, [
                    d_1.v('div', { classes: bs.p1 + " " + ownCss.scalarNodes }, [
                        d_1.v('div', { classes: bs.mb2 }, [
                            d_1.v('select', {
                                classes: bs.customSelect,
                                onchange: function (event) {
                                    // @ts-ignore
                                    _this.dialogState.scalar.name = event.target.value;
                                }
                            }, this.scalarNodeNames.map(function (nodeName) { return d_1.v('option', { value: nodeName }, [nodeName]); }))
                        ]),
                        d_1.v('div', { classes: bs.mb2 }, [
                            d_1.v('select', {
                                classes: bs.customSelect
                            }, this.properties.fieldNames.map(function (fieldName) { return d_1.v('option', { value: fieldName }, [fieldName]); }))
                        ]),
                        d_1.v('div', { classes: bs.mb2 }, [
                            d_1.v('input', {
                                type: 'text',
                                classes: bs.formControl,
                                value: this.dialogState.scalar.value,
                                onchange: function (event) {
                                    // @ts-ignore
                                    _this.dialogState.scalar.value = event.target.value;
                                    _this.invalidate();
                                }
                            })
                        ]),
                        d_1.v('button', {
                            classes: bs.btn + " " + bs.btnSm + " " + bs.btnPrimary + " " + bs.btnBlock,
                            onclick: function () {
                                _this.createChildNode(_this.dialogState.scalar.name, {
                                    field: _this.dialogState.scalar.field,
                                    value: _this.dialogState.scalar.value
                                });
                            }
                        }, ['Create node'])
                    ])
                ]),
                d_1.w(title_pane_1.default, {
                    extraClasses: {
                        title: '',
                        root: "" + bs.overflowHidden,
                        titleButton: bs.btn + " " + bs.btnLight + " " + bs.w100 + " " + bs.positionRelative,
                        arrow: "" + bs.pr1
                    },
                    title: 'Array Nodes',
                    key: '3'
                }, [
                    d_1.v('div', { classes: bs.p1 + " " + ownCss.arrayNodes }, [
                        d_1.v('div', { classes: bs.mb2 }, [
                            d_1.v('select', {
                                classes: bs.customSelect,
                                onChange: function (event) {
                                    // @ts-ignore
                                    _this.dialogState.array.name = event.target.value;
                                }
                            }, this.arrayNodeNames.map(function (nodeName) { return d_1.v('option', { value: nodeName }, [nodeName]); }))
                        ]),
                        d_1.v('div', { classes: bs.mb2 }, [
                            d_1.v('select', {
                                classes: bs.customSelect,
                                onChange: function (event) {
                                    // @ts-ignore
                                    _this.dialogState.array.field = event.target.value;
                                }
                            }, this.properties.fieldNames.map(function (nodeName) { return d_1.v('option', { value: nodeName }, [nodeName]); }))
                        ]),
                        d_1.v('div', { classes: bs.mb2 }, [
                            d_1.v('input', {
                                type: 'text',
                                classes: bs.formControl,
                                value: this.dialogState.array.value,
                                onchange: function (event) {
                                    // @ts-ignore
                                    _this.dialogState.array.value = event.target.value;
                                    _this.invalidate();
                                }
                            })
                        ]),
                        d_1.v('button', {
                            classes: bs.btn + " " + bs.btnSm + " " + bs.btnPrimary + " " + bs.btnBlock,
                            onclick: function () {
                                _this.createChildNode(_this.dialogState.array.name, {
                                    field: _this.dialogState.array.field,
                                    values: _this.dialogState.array.value.split(',')
                                });
                            }
                        }, ['Create node'])
                    ])
                ])
            ]);
        };
        ChildNodeCreationForm.prototype.createChildNode = function (nodeName, params) {
            this.properties.onChildNodeCreate(nodeName, params);
        };
        return ChildNodeCreationForm;
    }(WidgetBase_1.default));
    exports.default = ChildNodeCreationForm;
});
//# sourceMappingURL=ChildNodeCreationForm.js.map