(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@dojo/framework/widget-core/WidgetBase", "../../../dialog/Dialog", "./ChildNodeCreationForm", "@dojo/framework/widget-core/d"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var WidgetBase_1 = require("@dojo/framework/widget-core/WidgetBase");
    var Dialog_1 = require("../../../dialog/Dialog");
    var ChildNodeCreationForm_1 = require("./ChildNodeCreationForm");
    var d_1 = require("@dojo/framework/widget-core/d");
    var ChildNodeCreationFormDialog = /** @class */ (function (_super) {
        tslib_1.__extends(ChildNodeCreationFormDialog, _super);
        function ChildNodeCreationFormDialog() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ChildNodeCreationFormDialog.prototype.render = function () {
            var _a = this.properties, isOpen = _a.isOpen, closeDialog = _a.closeDialog, onChildNodeCreate = _a.onChildNodeCreate, fieldNames = _a.fieldNames;
            return d_1.w(Dialog_1.default, {
                title: 'Create new node',
                isOpen: isOpen,
                onClose: function () {
                    closeDialog();
                },
                options: {
                    centered: true
                }
            }, [
                d_1.w(ChildNodeCreationForm_1.default, {
                    onChildNodeCreate: function (nodeName, params) {
                        onChildNodeCreate(nodeName, params);
                        closeDialog();
                    },
                    fieldNames: fieldNames
                })
            ]);
        };
        return ChildNodeCreationFormDialog;
    }(WidgetBase_1.default));
    exports.default = ChildNodeCreationFormDialog;
});
//# sourceMappingURL=ChildNodeCreationFormDialog.js.map