(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@dojo/framework/widget-core/WidgetBase", "@dojo/framework/widget-core/d", "./selectNodeEditor.m.css", "../nodeFieldName/NodeFieldName", "rollun-common/dist/css/bootstrap.m.css", "rollun-common/dist/css/fontawesome.m.css", "rollun-common/dist/css/solid.m.css", "../common/common.m.css"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var WidgetBase_1 = require("@dojo/framework/widget-core/WidgetBase");
    var d_1 = require("@dojo/framework/widget-core/d");
    var css = require("./selectNodeEditor.m.css");
    var NodeFieldName_1 = require("../nodeFieldName/NodeFieldName");
    var bs = require("rollun-common/dist/css/bootstrap.m.css");
    var fa = require("rollun-common/dist/css/fontawesome.m.css");
    var faSolid = require("rollun-common/dist/css/solid.m.css");
    var commonCss = require("../common/common.m.css");
    var SelectNodeEditor = /** @class */ (function (_super) {
        tslib_1.__extends(SelectNodeEditor, _super);
        function SelectNodeEditor() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.awaitingDrop = false;
            _this.validDropTarget = false;
            return _this;
        }
        SelectNodeEditor.prototype.render = function () {
            var _this = this;
            var cardClasses = bs.dFlex + " " + bs.flexColumn + " " + bs.card + " " + bs.m1 + " " + bs.h100 + " " + commonCss.transparentBorder + " " + css.root;
            if (this.awaitingDrop) {
                cardClasses += this.validDropTarget ? commonCss.validBorder + ' ' : commonCss.invalidBorder + ' ';
            }
            return d_1.v('div', { classes: cardClasses }, [
                d_1.v('div', {
                    classes: bs.cardBody + " " + bs.p3 + " " + bs.border,
                    ondragover: function (event) {
                        _this.checkDropPossibility(event);
                    },
                    ondragleave: function (event) {
                        _this.disableDropTarget();
                    },
                    ondrop: function (event) {
                        _this.addDroppedNodeToSelectedNodes(event);
                    }
                }, [
                    d_1.v('div', { classes: bs.dFlex + " " + bs.flexRow + " " + bs.cardTitle + " " + css.controls }, [
                        d_1.v('div', {
                            classes: bs.dFlex + " " + bs.justifyContentCenter + " " + css.titleContainer,
                        }, [
                            d_1.v('div', {}, ['Selected fields'])
                        ]),
                        d_1.v('div', {
                            classes: bs.dFlex + " " + bs.justifyContentEnd + " " + css.closeBtnContainer,
                        }, [
                            d_1.v('button', {
                                classes: bs.btn + " " + bs.btnSm + " " + bs.btnDanger,
                                onclick: function () { return _this.properties.onRemove(); }
                            }, [
                                d_1.v('i', { classes: faSolid.fas + " " + fa.faTimes })
                            ])
                        ])
                    ]),
                    d_1.v('div', { classes: bs.dFlex + " " + bs.cardText + " " + css.activeNodesContainer }, [
                        d_1.v('div', {
                            classes: bs.dFlex + " " + bs.flexColumn + " " + bs.w100 + " " + css.activeSelectNodes,
                        }, this.properties.node.fields.map(function (fieldName) {
                            return d_1.w(NodeFieldName_1.default, { fieldName: fieldName, isActive: true, nodeType: 'selectnode' });
                        }))
                    ])
                ])
            ]);
        };
        SelectNodeEditor.prototype.addFieldToNode = function (fieldName) {
            // if node is already present, remove it and add it to the end
            var fieldNameIndex = this.properties.node.fields.indexOf(fieldName);
            if (fieldNameIndex !== -1) {
                this.properties.node.fields.splice(fieldNameIndex, 1);
            }
            this.properties.node.fields.push(fieldName);
            this.properties.onSelectNodeChange(tslib_1.__spread(this.properties.node.fields));
        };
        SelectNodeEditor.prototype.checkDropPossibility = function (event) {
            event.preventDefault();
            if (event.dataTransfer.types.indexOf('nodefieldname') !== -1) {
                this.awaitingDrop = true;
                this.validDropTarget = true;
                this.invalidate();
                return false;
            }
            return true;
        };
        SelectNodeEditor.prototype.disableDropTarget = function () {
            this.awaitingDrop = false;
            this.validDropTarget = false;
            this.invalidate();
        };
        SelectNodeEditor.prototype.addDroppedNodeToSelectedNodes = function (event) {
            this.addFieldToNode(event.dataTransfer.getData('nodefieldname'));
            this.disableDropTarget();
        };
        return SelectNodeEditor;
    }(WidgetBase_1.default));
    exports.default = SelectNodeEditor;
});
//# sourceMappingURL=SelectNodeEditor.js.map