(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@dojo/framework/widget-core/WidgetBase", "./sortNodeEditor.m.css", "@dojo/framework/widget-core/d", "./SortNodeFieldEditor", "rollun-common/dist/css/bootstrap.m.css", "rollun-common/dist/css/fontawesome.m.css", "rollun-common/dist/css/solid.m.css", "../common/common.m.css"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var WidgetBase_1 = require("@dojo/framework/widget-core/WidgetBase");
    var css = require("./sortNodeEditor.m.css");
    var d_1 = require("@dojo/framework/widget-core/d");
    var SortNodeFieldEditor_1 = require("./SortNodeFieldEditor");
    var bs = require("rollun-common/dist/css/bootstrap.m.css");
    var fa = require("rollun-common/dist/css/fontawesome.m.css");
    var faSolid = require("rollun-common/dist/css/solid.m.css");
    var commonCss = require("../common/common.m.css");
    var SortNodeEditor = /** @class */ (function (_super) {
        tslib_1.__extends(SortNodeEditor, _super);
        function SortNodeEditor() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.awaitingDrop = false;
            _this.validDropTarget = false;
            return _this;
        }
        SortNodeEditor.prototype.render = function () {
            var _this = this;
            var classes = bs.card + " " + bs.m1 + " " + bs.h100 + " " + commonCss.transparentBorder + " " + css.root;
            if (this.awaitingDrop === true) {
                classes += this.validDropTarget ? " " + commonCss.validBorder : " " + commonCss.invalidBorder;
            }
            return d_1.v('div', { classes: classes }, [
                d_1.v('div', {
                    classes: " " + bs.cardBody + " " + bs.p3 + " " + bs.border + " " + css.sort,
                    ondragover: this.checkSortOptionValidity,
                    ondrop: this.addNewSortOption,
                    ondragleave: function () {
                        _this.disableDropTarget();
                    }
                }, [
                    d_1.v('div', { classes: bs.dFlex + " " + bs.flexRow + " " + bs.cardTitle + " " + css.titleRow }, [
                        d_1.v('div', {
                            classes: bs.dFlex + " " + bs.justifyContentStart + " " + css.titleContainer
                        }, [
                            d_1.v('span', {}, ['Sort fields'])
                        ]),
                        d_1.v('div', {
                            classes: bs.dFlex + " " + bs.flexRow + " " + bs.justifyContentEnd + " " + css.closeBtnContainer,
                        }, [
                            d_1.v('button', {
                                classes: bs.btn + " " + bs.btnSm + " " + bs.btnDanger,
                                onclick: function () {
                                    _this.properties.onRemove();
                                }
                            }, [
                                d_1.v('i', { classes: faSolid.fas + " " + fa.faTimes })
                            ])
                        ])
                    ]),
                    d_1.v('div', { classes: bs.dFlex + " " + bs.flexColumn + " " + css.activeSortNodes + " " + bs.cardText }, this.renderSortEditors())
                ])
            ]);
        };
        SortNodeEditor.prototype.renderSortEditors = function () {
            var _this = this;
            var result = [];
            var onSortDirectionChange = function (fieldName, sortDirection) {
                _this.changeSortOption(fieldName, sortDirection);
            };
            Object.entries(this.properties.node.sortOptions).forEach(function (entry) {
                var _a = tslib_1.__read(entry, 2), fieldName = _a[0], sortDirection = _a[1];
                result.push(d_1.w(SortNodeFieldEditor_1.default, { fieldName: fieldName, sortDirection: sortDirection, onSortDirectionChange: onSortDirectionChange }));
            });
            return result;
        };
        SortNodeEditor.prototype.checkSortOptionValidity = function (event) {
            event.preventDefault();
            this.awaitingDrop = true;
            if (event.dataTransfer.types.indexOf('nodefieldname') !== -1) {
                this.validDropTarget = true;
                this.invalidate();
                return false;
            }
            this.invalidate();
            return true;
        };
        SortNodeEditor.prototype.addNewSortOption = function (event) {
            var fieldName = event.dataTransfer.getData('nodefieldname');
            this.properties.node.sortOptions[fieldName] = 1;
            var newSortOptions = Object.assign({}, this.properties.node.sortOptions);
            this.properties.onSortNodeChange(newSortOptions);
            this.disableDropTarget();
            this.invalidate();
        };
        SortNodeEditor.prototype.disableDropTarget = function () {
            this.awaitingDrop = false;
            this.validDropTarget = false;
            this.invalidate();
        };
        SortNodeEditor.prototype.changeSortOption = function (fieldName, sortDirection) {
            this.properties.node.sortOptions[fieldName] = sortDirection;
            var newSortOptions = Object.assign({}, this.properties.node.sortOptions);
            this.properties.onSortNodeChange(newSortOptions);
        };
        return SortNodeEditor;
    }(WidgetBase_1.default));
    exports.default = SortNodeEditor;
});
//# sourceMappingURL=SortNodeEditor.js.map