(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@dojo/framework/widget-core/WidgetBase", "@dojo/framework/widget-core/d", "./sortNodeFieldEditor.m.css", "rollun-common/dist/css/fontawesome.m.css", "rollun-common/dist/css/solid.m.css", "rollun-common/dist/css/bootstrap.m.css", "../../common/common.m.css"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var WidgetBase_1 = require("@dojo/framework/widget-core/WidgetBase");
    var d_1 = require("@dojo/framework/widget-core/d");
    var css = require("./sortNodeFieldEditor.m.css");
    var fa = require("rollun-common/dist/css/fontawesome.m.css");
    var faSolid = require("rollun-common/dist/css/solid.m.css");
    var bs = require("rollun-common/dist/css/bootstrap.m.css");
    var commonCss = require("../../common/common.m.css");
    var SortNodeFieldEditor = /** @class */ (function (_super) {
        tslib_1.__extends(SortNodeFieldEditor, _super);
        function SortNodeFieldEditor() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        SortNodeFieldEditor.prototype.render = function () {
            var _this = this;
            var _a = this.properties, fieldName = _a.fieldName, sortDirection = _a.sortDirection, onSortDirectionChange = _a.onSortDirectionChange;
            return d_1.v('div', {
                classes: bs.dFlex + " " + bs.flexRow + " " + bs.mb1 + "  " + css.sortRow,
                draggable: true,
                ondragstart: function (event) {
                    _this.handleDragStart(event);
                }
            }, [
                d_1.v('div', {
                    classes: bs.py1 + " " + bs.px2 + " " + bs.w100 + " " + css.sortFieldName + " " + commonCss.headerCellFont
                }, [fieldName]),
                d_1.v('button', {
                    classes: "" + css.changeSortDirectionButton,
                    onclick: function () {
                        onSortDirectionChange(fieldName, (sortDirection === -1 ? 1 : -1));
                    }
                }, [sortDirection === 1
                        ? d_1.v('i', { classes: faSolid.fas + " " + fa.faCaretUp })
                        : d_1.v('i', { classes: faSolid.fas + " " + fa.faCaretDown })
                ])
            ]);
        };
        SortNodeFieldEditor.prototype.handleDragStart = function (event) {
            event.dataTransfer.setData('nodefieldname', this.properties.fieldName);
        };
        return SortNodeFieldEditor;
    }(WidgetBase_1.default));
    exports.default = SortNodeFieldEditor;
});
//# sourceMappingURL=SortNodeFieldEditor.js.map