(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@dojo/framework/widget-core/WidgetBase", "@dojo/framework/widget-core/d", "rollun-common/dist/css/bootstrap.m.css", "../dialog/Dialog", "../queryEditor/queryEditor/QueryEditor"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var WidgetBase_1 = require("@dojo/framework/widget-core/WidgetBase");
    var d_1 = require("@dojo/framework/widget-core/d");
    var bs = require("rollun-common/dist/css/bootstrap.m.css");
    var Dialog_1 = require("../dialog/Dialog");
    var QueryEditor_1 = require("../queryEditor/queryEditor/QueryEditor");
    var QueryEditorInModal = /** @class */ (function (_super) {
        tslib_1.__extends(QueryEditorInModal, _super);
        function QueryEditorInModal() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        QueryEditorInModal.prototype.render = function () {
            var _this = this;
            if (!this.isStarted) {
                this.context = this.properties.context;
                this.context.query = this.properties.query;
                this.isStarted = true;
            }
            var _a = this.properties, applyQuery = _a.applyQuery, isOpen = _a.isOpen, openDialog = _a.openDialog, closeDialog = _a.closeDialog;
            this.context.fieldNames = this.properties.fieldNames;
            return d_1.v('div', {
                styles: {}
            }, [
                d_1.w(Dialog_1.default, {
                    title: 'Edit query',
                    isOpen: isOpen,
                    onClose: function () {
                        closeDialog();
                    },
                    options: {
                        size: 3,
                        centered: true
                    }
                }, [
                    d_1.v('div', {
                        classes: bs.dFlex + " " + bs.flexGrow1
                    }, [
                        d_1.w(QueryEditor_1.default, {
                            query: this.context.query,
                            context: this.context,
                            fieldNames: this.context.fieldNames
                        }),
                    ]),
                    d_1.v('div', { classes: "" + bs.w100 }, [
                        d_1.v('btn', {
                            classes: bs.btn + " " + bs.btnPrimary + " " + bs.btnSm + " " + bs.justifyContentCenter,
                            styles: { 'width': '200px' },
                            onclick: function () {
                                applyQuery(_this.context.query);
                                closeDialog();
                            }
                        }, ['Apply query'])
                    ]),
                ]),
                d_1.v('button', {
                    classes: bs.btn + " " + bs.btnPrimary + " " + bs.btnSm,
                    onclick: function () {
                        openDialog();
                    }
                }, ['Edit query'])
            ]);
        };
        return QueryEditorInModal;
    }(WidgetBase_1.default));
    exports.default = QueryEditorInModal;
});
//# sourceMappingURL=QueryEditorContainerModal.js.map