(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "rollun-ts-rql/dist/nodes/arrayNodes/In", "rollun-ts-rql/dist/nodes/arrayNodes/Out", "rollun-ts-rql/dist/nodes/logicalNodes/And", "rollun-ts-rql/dist/nodes/logicalNodes/Or", "rollun-ts-rql/dist/nodes/logicalNodes/Not", "rollun-ts-rql/dist/nodes/scalarNodes/Alike", "rollun-ts-rql/dist/nodes/scalarNodes/Like", "rollun-ts-rql/dist/nodes/scalarNodes/Eq", "rollun-ts-rql/dist/nodes/scalarNodes/Ge", "rollun-ts-rql/dist/nodes/scalarNodes/Gt", "rollun-ts-rql/dist/nodes/scalarNodes/Le", "rollun-ts-rql/dist/nodes/scalarNodes/Lt", "rollun-ts-rql/dist/nodes/scalarNodes/Ne"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var In_1 = require("rollun-ts-rql/dist/nodes/arrayNodes/In");
    var Out_1 = require("rollun-ts-rql/dist/nodes/arrayNodes/Out");
    var And_1 = require("rollun-ts-rql/dist/nodes/logicalNodes/And");
    var Or_1 = require("rollun-ts-rql/dist/nodes/logicalNodes/Or");
    var Not_1 = require("rollun-ts-rql/dist/nodes/logicalNodes/Not");
    var Alike_1 = require("rollun-ts-rql/dist/nodes/scalarNodes/Alike");
    var Like_1 = require("rollun-ts-rql/dist/nodes/scalarNodes/Like");
    var Eq_1 = require("rollun-ts-rql/dist/nodes/scalarNodes/Eq");
    var Ge_1 = require("rollun-ts-rql/dist/nodes/scalarNodes/Ge");
    var Gt_1 = require("rollun-ts-rql/dist/nodes/scalarNodes/Gt");
    var Le_1 = require("rollun-ts-rql/dist/nodes/scalarNodes/Le");
    var Lt_1 = require("rollun-ts-rql/dist/nodes/scalarNodes/Lt");
    var Ne_1 = require("rollun-ts-rql/dist/nodes/scalarNodes/Ne");
    var RqlNodeFactory = /** @class */ (function () {
        function RqlNodeFactory() {
        }
        RqlNodeFactory.prototype.createNode = function (name, params) {
            var parsedParams = Object.assign({
                field: '',
                value: '',
                values: [],
                subNodes: []
            }, params);
            var newNode;
            switch (name) {
                case 'in': {
                    newNode = new In_1.default(parsedParams.field, parsedParams.values);
                    break;
                }
                case 'out': {
                    newNode = new Out_1.default(parsedParams.field, parsedParams.values);
                    break;
                }
                case 'and': {
                    newNode = new And_1.default(parsedParams.subNodes);
                    break;
                }
                case 'or': {
                    newNode = new Or_1.default(parsedParams.subNodes);
                    break;
                }
                case 'not': {
                    newNode = new Not_1.default(parsedParams.subNodes);
                    break;
                }
                case 'like': {
                    newNode = new Like_1.default(parsedParams.field, parsedParams.value);
                    break;
                }
                case 'alike': {
                    newNode = new Alike_1.default(parsedParams.field, parsedParams.value);
                    break;
                }
                case 'eq': {
                    newNode = new Eq_1.default(parsedParams.field, parsedParams.value);
                    break;
                }
                case 'ge': {
                    newNode = new Ge_1.default(parsedParams.field, parsedParams.value);
                    break;
                }
                case 'gt': {
                    newNode = new Gt_1.default(parsedParams.field, parsedParams.value);
                    break;
                }
                case 'le': {
                    newNode = new Le_1.default(parsedParams.field, parsedParams.value);
                    break;
                }
                case 'lt': {
                    newNode = new Lt_1.default(parsedParams.field, parsedParams.value);
                    break;
                }
                case 'ne': {
                    newNode = new Ne_1.default(parsedParams.field, parsedParams.value);
                    break;
                }
                default:
                    throw new Error("Unknown node " + name);
            }
            return newNode;
        };
        return RqlNodeFactory;
    }());
    exports.default = RqlNodeFactory;
});
//# sourceMappingURL=RqlNodeFactory.js.map