import * as tslib_1 from "tslib";
import { WidgetBase } from '@dojo/framework/widget-core/WidgetBase';
import { inject } from '@dojo/framework/widget-core/decorators/inject';
import { w } from '@dojo/framework/widget-core/d';
import { alwaysRender } from '@dojo/framework/widget-core/decorators/alwaysRender';
export function MultiContextContainer(component, contextReducers) {
    let WidgetContainer = class WidgetContainer extends WidgetBase {
        constructor() {
            super();
            Object.keys(contextReducers).forEach((contextName) => {
                inject({
                    name: contextName,
                    getProperties: contextReducers[contextName]
                })(this);
            });
        }
        render() {
            return w(component, this.properties, this.children);
        }
    };
    WidgetContainer = tslib_1.__decorate([
        alwaysRender(),
        tslib_1.__metadata("design:paramtypes", [])
    ], WidgetContainer);
    return WidgetContainer;
}
export default MultiContextContainer;
//# sourceMappingURL=MultiContextContainer.mjs.map