import { QueryAppDialogNames } from '../context/QueryAppContext';
import RowEditorDialog from '../dialog/RowEditorDialog';
import MultiContextContainer from '../common/MultiContextContainer';
function getPropertiesFromQueryAppContext(inject, properties) {
    const formConfig = inject.datastoreData[0] ? Object.keys(inject.datastoreData[0]).map((fieldName) => {
        return { field: fieldName };
    })
        : [];
    const item = inject.datastoreData[0] ?
        inject.datastoreData[inject.selectedGridRowIndex]
        : {};
    const isOpen = inject.dialogs.get(QueryAppDialogNames.editSelectedRowDialog).shown;
    const openDialog = () => { inject.dialogs.show(QueryAppDialogNames.editSelectedRowDialog); };
    const closeDialog = () => { inject.dialogs.hide(QueryAppDialogNames.editSelectedRowDialog); };
    return {
        formConfig,
        onFormSubmit: inject.changeRowValue.bind(inject),
        item,
        isOpen,
        openDialog,
        closeDialog
    };
}
function getPropertiesFromGridContext(inject, properties) {
    const selectedRowIndex = inject.selectedRowIndex;
    return { selectedRowIndex };
}
const RowEditorDialogContainer = MultiContextContainer(RowEditorDialog, {
    'queryAppContext': getPropertiesFromQueryAppContext,
    'gridContext': getPropertiesFromGridContext
});
export default RowEditorDialogContainer;
//# sourceMappingURL=RowEditorDialogContainer.mjs.map