import QueryEditorContainerModal from '../../queryEditorInWrapper/QueryEditorContainerModal';
import MultiContextContainer from '../../common/MultiContextContainer';
import { QueryAppDialogNames } from '../../context/QueryAppContext';
function getPropertiesFromAppContext(inject, properties) {
    const isOpen = inject.dialogs.get(QueryAppDialogNames.editQueryDialog).shown;
    const openDialog = () => { inject.dialogs.show(QueryAppDialogNames.editQueryDialog); };
    const closeDialog = () => { inject.dialogs.hide(QueryAppDialogNames.editQueryDialog); };
    return {
        isOpen,
        openDialog,
        closeDialog,
        query: inject.query,
        applyQuery: (query) => {
            inject.query = query;
            inject.reloadGridData();
        },
        fieldNames: inject.datastoreData[0]
            ? Object.keys(inject.datastoreData[0])
            : []
    };
}
function getPropertiesFromQueryEditorContext(inject, properties) {
    return {
        context: inject
    };
}
const QueryEditorContainerModalContainer = MultiContextContainer(QueryEditorContainerModal, {
    'queryAppContext': getPropertiesFromAppContext,
    'queryEditorContext': getPropertiesFromQueryEditorContext,
});
export default QueryEditorContainerModalContainer;
//# sourceMappingURL=queryEditorContainerModalContainer.mjs.map