export default class DialogController {
    constructor(invalidator, initialStatus) {
        this._invalidator = invalidator;
        this._dialogs = new Map(Object.entries(initialStatus));
    }
    show(dialogId) {
        const currentStatus = this._dialogs.get(dialogId);
        if (currentStatus) {
            currentStatus.shown = true;
            this._dialogs.set(dialogId, currentStatus);
            this._invalidator();
        }
    }
    hide(dialogId) {
        const currentStatus = this._dialogs.get(dialogId);
        if (currentStatus) {
            currentStatus.shown = false;
            this._dialogs.set(dialogId, currentStatus);
            this._invalidator();
        }
    }
    has(dialogId) {
        return this._dialogs.has(dialogId);
    }
    get(dialogId) {
        return this._dialogs.get(dialogId);
    }
    set(dialogId, status) {
        this._dialogs.set(dialogId, status);
        this._invalidator();
    }
}
//# sourceMappingURL=DialogController.mjs.map