export default class GridContext {
    constructor(invalidator, initialState) {
        this._invalidator = invalidator;
        if (initialState.fields) {
            this._rowFields = initialState.fields;
        }
        if (initialState.rows) {
            this._rowRows = initialState.rows;
        }
    }
    get rowFields() {
        return this._rowFields;
    }
    set rowFields(fields) {
        this._rowFields = fields;
        this._invalidator();
    }
    get rowRows() {
        return this._rowRows;
    }
    set rowRows(rows) {
        this._rowRows = rows;
        this._invalidator();
    }
    set changeDataItem(value) {
        this._changeDataItem = value;
    }
    get selectedRowIndex() {
        return this._selectedRowIndex;
    }
    changeCellValue(rowIndex, columnIndex, value) {
        this._changeDataItem(rowIndex, columnIndex, value);
    }
    selectRow(index) {
        this._selectedRowIndex = index;
        this._invalidator();
    }
}
//# sourceMappingURL=GridContext.mjs.map