import { LoadingStatusEnum } from '../../common/interfaces';
export default class AbstractDataUpdater {
    get loadingStatus() {
        return this._loadingStatus;
    }
    get data() {
        return this._data;
    }
    updateData() {
        this._loadingStatus = LoadingStatusEnum.loading;
        return new Promise((resolve, reject) => {
            this._updateData().then((data) => {
                this._data = this.afterProcess(data);
                this._loadingStatus = LoadingStatusEnum.loaded;
                resolve();
            }, (error) => {
                this._loadingStatus = LoadingStatusEnum.error;
                reject(error);
            });
        });
    }
    afterProcess(data) {
        return data;
    }
}
//# sourceMappingURL=AbstractDataUpdater.mjs.map