import AbstractDataUpdater from './AbstractDataUpdater';
import QueryManager from '../../queryManager/QueryManager';
export default class AbstractDatastoreDataUpdater extends AbstractDataUpdater {
    constructor(datastore) {
        super();
        this._datastore = datastore;
        this._queryManager = new QueryManager();
    }
    set query(query) {
        this._queryManager.setQuery(query);
    }
    get query() {
        return this._queryManager.getQuery();
    }
    _updateData() {
        return new Promise((resolve, reject) => {
            this._datastore.query(this.getProcessedQuery()).then((data) => {
                resolve(data);
            }, (error) => {
                reject(error);
            });
        });
    }
}
//# sourceMappingURL=AbstractDatastoreDataUpdater.mjs.map