import Query from 'rollun-ts-rql/dist/Query';
import AbstractDatastoreDataUpdater from './AbstractDatastoreDataUpdater';
import Select from 'rollun-ts-rql/dist/nodes/Select';
import AggregateFunctionNode from 'rollun-ts-rql/dist/nodes/aggregateNodes/AggregateFunctionNode';
export default class DatastoreCountUpdater extends AbstractDatastoreDataUpdater {
    constructor() {
        super(...arguments);
        this._data = 0;
    }
    getProcessedQuery() {
        const oldQuery = this._queryManager.getQuery();
        return new Query({
            select: oldQuery.selectNode
                ? new Select([
                    ...oldQuery.selectNode.fields,
                    new AggregateFunctionNode('count', 'id')
                ])
                : new Select([
                    new AggregateFunctionNode('count', 'id')
                ])
        });
    }
    afterProcess(data) {
        return data[0]['count(id)'];
    }
}
//# sourceMappingURL=DatastoreCountUpdater.mjs.map