import WidgetBase from '@dojo/framework/widget-core/WidgetBase';
import * as bs from 'rollun-common/dist/css/bootstrap.m.css';
import { tsx } from '@dojo/framework/widget-core/tsx';
import FluidForm from '../form/FluidForm';
import Dialog from './Dialog';
export default class NewItemCreatorDialog extends WidgetBase {
    render() {
        const { formConfig, title, isOpen } = this.properties;
        const onFormSubmit = (data) => {
            this.properties.onFormSubmit(data);
        };
        return (tsx("div", null,
            tsx("button", { class: `${bs.btn} ${bs.btnPrimary} ${bs.btnSm}`, onclick: () => {
                    this.properties.openDialog();
                } }, "Add new item"),
            tsx(Dialog, { isOpen: isOpen, title: title, onClose: () => {
                    this.properties.closeDialog();
                }, options: {
                    size: 2,
                    centered: true
                } },
                tsx(FluidForm, { formConfig: formConfig, onFormSubmit: onFormSubmit }))));
    }
}
//# sourceMappingURL=NewItemCreatorDialog.mjs.map