import WidgetBase from '@dojo/framework/widget-core/WidgetBase';
import { v, w } from '@dojo/framework/widget-core/d';
import * as bootstrap from 'rollun-common/dist/css/bootstrap.m.css';
import CellEditorContainer from '../../../containers/grid/CellEditorContainer';
export class Cell extends WidgetBase {
    render() {
        return v('td', this.getCellNodeProperties(), [
            this.getValue()
        ]);
    }
    getCellNodeProperties() {
        const cellNodeProps = {
            classes: `${bootstrap.p1} ${bootstrap.alignItemsCenter} ${bootstrap.borderLeft}`,
            styles: {
                minWidth: '100px'
            }
        };
        if (this.properties.minWidth) {
            cellNodeProps.styles.minWidth = this.properties.minWidth + 'px';
        }
        if (this.properties.isEditable) {
            cellNodeProps.ondblclick = () => {
                this.isEdited = true;
                this.invalidate();
            };
        }
        return cellNodeProps;
    }
    getValue() {
        if (this.isEdited) {
            const { rowIndex, columnIndex } = this.properties;
            const onStopEditing = () => {
                this.isEdited = false;
                this.invalidate();
            };
            return w(CellEditorContainer, { rowIndex, columnIndex, onStopEditing });
        }
        else {
            return this.properties.value;
        }
    }
}
//# sourceMappingURL=Cell.mjs.map