import WidgetBase from '@dojo/framework/widget-core/WidgetBase';
import { v } from '@dojo/framework/widget-core/d';
import * as bs from 'rollun-common/dist/css/bootstrap.m.css';
export default class CellEditor extends WidgetBase {
    onAttach() {
        document.onkeyup = (event) => {
            switch (event.code) {
                case 'Enter':
                    this.finishEditing();
                    break;
                case 'Escape':
                    this.cancelEditing();
                    break;
            }
        };
    }
    render() {
        if (!this.isStarted) {
            this.value = this.properties.value;
            this.isStarted = true;
        }
        return v('input', {
            type: 'text',
            classes: `${bs.w100}`,
            value: this.value,
            focus: () => true,
            oninput: (event) => {
                // @ts-ignore
                this.value = event.target.value;
                this.invalidate();
            },
            onblur: () => {
                this.finishEditing();
            }
        });
    }
    finishEditing() {
        const { rowIndex, columnIndex } = this.properties;
        this.properties.onCellValueUpdate(rowIndex, columnIndex, this.value);
        this.properties.onStopEditing();
    }
    cancelEditing() {
        this.properties.onStopEditing();
    }
    onDetach() {
        delete document.onkeyup;
    }
}
//# sourceMappingURL=CellEditor.mjs.map