import WidgetBase from '@dojo/framework/widget-core/WidgetBase';
import { v, w } from '@dojo/framework/widget-core/d';
import * as bs from 'rollun-common/dist/css/bootstrap.m.css';
import CellContainer from '../../../../containers/grid/CellContainer';
export class Row extends WidgetBase {
    render() {
        return this.basicRender();
    }
    basicRender() {
        const { rowFields, rowIndex } = this.properties;
        return v('tr', this.getRowNodeProperties(), rowFields.fieldsInfo.map((fieldInfo, columnIndex) => {
            return w(CellContainer, { rowIndex, columnIndex, key: `cell-${rowIndex}-${columnIndex}` });
        }));
    }
    getRowNodeProperties() {
        const { isSelected } = this.properties;
        const properties = {
            classes: `${bs.borderBottom} ${isSelected ? bs.bgLight : ''}`,
            onclick: () => {
                if (!isSelected) {
                    this.properties.onSelect();
                }
            }
        };
        return properties;
    }
}
//# sourceMappingURL=Row.mjs.map