import WidgetBase from '@dojo/framework/widget-core/WidgetBase';
import Dialog from '../../../dialog/Dialog';
import ChildNodeCreationForm from './ChildNodeCreationForm';
import { w } from '@dojo/framework/widget-core/d';
export default class ChildNodeCreationFormDialog extends WidgetBase {
    render() {
        const { isOpen, closeDialog, onChildNodeCreate, fieldNames } = this.properties;
        return w(Dialog, {
            title: 'Create new node',
            isOpen,
            onClose: () => {
                closeDialog();
            },
            options: {
                centered: true
            }
        }, [
            w(ChildNodeCreationForm, {
                onChildNodeCreate: (nodeName, params) => {
                    onChildNodeCreate(nodeName, params);
                    closeDialog();
                },
                fieldNames
            })
        ]);
    }
}
//# sourceMappingURL=ChildNodeCreationFormDialog.mjs.map