import * as tslib_1 from "tslib";
import WidgetBase from '@dojo/framework/widget-core/WidgetBase';
import { v } from '@dojo/framework/widget-core/d';
import * as ownCss from './scalarNode.m.css';
import * as bootstrap from 'rollun-common/dist/css/bootstrap.m.css';
import * as fa from 'rollun-common/dist/css/fontawesome.m.css';
import * as faSolid from 'rollun-common/dist/css/solid.m.css';
import diffProperty from '@dojo/framework/widget-core/decorators/diffProperty';
import { undefinedSafeDiffNode } from '../../../common/functions';
export default class ScalarNodeEditor extends WidgetBase {
    render() {
        return v('div', { classes: ownCss.root }, [
            v('div', { classes: `${bootstrap.dFlex} ${bootstrap.flexRow} ${ownCss.controlsContainer}` }, [
                v('select', {
                    classes: 'bootstrap.customSelect',
                    onChange: (event) => {
                        // @ts-ignore
                        this.properties.node.fieldName = event.target.value;
                    }
                }, this.properties.fieldNames.map((nodeName) => v('option', { value: nodeName, selected: nodeName === this.properties.node.name }, [nodeName]))),
                v('div', { classes: `${bootstrap.px3} ${bootstrap.py1} ${bootstrap.dFlex} ${bootstrap.alignItemsCenter}` }, [this.getHumanNodeName(this.properties.node.name)]),
                v('input', {
                    type: 'text',
                    classes: '${bootstrap.formControl}',
                    value: this.properties.node.value,
                    onchange: (event) => {
                        // @ts-ignore
                        this.properties.node.value = event.target.value;
                        this.invalidate();
                    }
                }),
            ]),
            v('div', { classes: `${bootstrap.dFlex} ${bootstrap.flexRowReverse} ${ownCss.closeBtnContainer}` }, [
                v('button', {
                    classes: `${ownCss.removeButton} ${bootstrap.btn} ${bootstrap.btnSm} ${bootstrap.btnDanger}`,
                    onclick: () => {
                        this.removeSelf();
                    }
                }, [
                    v('i', { classes: `${faSolid.fas} ${fa.faTimes}` })
                ])
            ])
        ]);
    }
    removeSelf() {
        this.properties.onRemove(this.properties.path);
    }
    getHumanNodeName(nodeName) {
        return nodeName;
    }
}
tslib_1.__decorate([
    diffProperty('node', undefinedSafeDiffNode),
    tslib_1.__metadata("design:type", Function),
    tslib_1.__metadata("design:paramtypes", []),
    tslib_1.__metadata("design:returntype", Object)
], ScalarNodeEditor.prototype, "render", null);
//# sourceMappingURL=ScalarNodeEditor.mjs.map