import WidgetBase from '@dojo/framework/widget-core/WidgetBase';
import { v, w } from '@dojo/framework/widget-core/d';
import * as bs from 'rollun-common/dist/css/bootstrap.m.css';
import Dialog from '../dialog/Dialog';
import QueryEditor from '../queryEditor/queryEditor/QueryEditor';
export default class QueryEditorInModal extends WidgetBase {
    render() {
        if (!this.isStarted) {
            this.context = this.properties.context;
            this.context.query = this.properties.query;
            this.isStarted = true;
        }
        const { applyQuery, isOpen, openDialog, closeDialog } = this.properties;
        this.context.fieldNames = this.properties.fieldNames;
        return v('div', {
            styles: {}
        }, [
            w(Dialog, {
                title: 'Edit query',
                isOpen,
                onClose: () => {
                    closeDialog();
                },
                options: {
                    size: 3,
                    centered: true
                }
            }, [
                v('div', {
                    classes: `${bs.dFlex} ${bs.flexGrow1}`
                }, [
                    w(QueryEditor, {
                        query: this.context.query,
                        context: this.context,
                        fieldNames: this.context.fieldNames
                    }),
                ]),
                v('div', { classes: `${bs.w100}` }, [
                    v('btn', {
                        classes: `${bs.btn} ${bs.btnPrimary} ${bs.btnSm} ${bs.justifyContentCenter}`,
                        styles: { 'width': '200px' },
                        onclick: () => {
                            applyQuery(this.context.query);
                            closeDialog();
                        }
                    }, ['Apply query'])
                ]),
            ]),
            v('button', {
                classes: `${bs.btn} ${bs.btnPrimary} ${bs.btnSm}`,
                onclick: () => {
                    openDialog();
                }
            }, ['Edit query'])
        ]);
    }
}
//# sourceMappingURL=QueryEditorContainerModal.mjs.map