(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var ContextConfig = /** @class */ (function () {
        function ContextConfig(ownContextClass, childWidgetClasses) {
            this._ownContextClass = ownContextClass;
            this._childWidgetClasses = childWidgetClasses;
        }
        ContextConfig.prototype.getContextClasses = function () {
            var contextClasses = [this._ownContextClass];
            this._childWidgetClasses.forEach(function (widgetClass) {
                if (widgetClass.contextConfig) {
                    contextClasses.push(widgetClass.contextConfig.getContextClasses());
                }
            });
            // @ts-ignore
            return contextClasses.flat();
        };
        return ContextConfig;
    }());
    exports.default = ContextConfig;
});
//# sourceMappingURL=ContextConfig.js.map