(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@dojo/framework/widget-core/WidgetBase", "@dojo/framework/widget-core/decorators/inject", "@dojo/framework/widget-core/d", "@dojo/framework/widget-core/decorators/alwaysRender"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var WidgetBase_1 = require("@dojo/framework/widget-core/WidgetBase");
    var inject_1 = require("@dojo/framework/widget-core/decorators/inject");
    var d_1 = require("@dojo/framework/widget-core/d");
    var alwaysRender_1 = require("@dojo/framework/widget-core/decorators/alwaysRender");
    function MultiContextContainer(component, contextReducers) {
        var WidgetContainer = /** @class */ (function (_super) {
            tslib_1.__extends(WidgetContainer, _super);
            function WidgetContainer() {
                var _this = _super.call(this) || this;
                Object.keys(contextReducers).forEach(function (contextName) {
                    inject_1.inject({
                        name: contextName,
                        getProperties: contextReducers[contextName]
                    })(_this);
                });
                return _this;
            }
            WidgetContainer.prototype.render = function () {
                return d_1.w(component, this.properties, this.children);
            };
            WidgetContainer = tslib_1.__decorate([
                alwaysRender_1.alwaysRender(),
                tslib_1.__metadata("design:paramtypes", [])
            ], WidgetContainer);
            return WidgetContainer;
        }(WidgetBase_1.WidgetBase));
        return WidgetContainer;
    }
    exports.MultiContextContainer = MultiContextContainer;
    exports.default = MultiContextContainer;
});
//# sourceMappingURL=MultiContextContainer.js.map