(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "@dojo/framework/widget-core/Container", "../context/QueryAppContext", "../dialog/NewItemCreatorDialog"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var Container_1 = require("@dojo/framework/widget-core/Container");
    var QueryAppContext_1 = require("../context/QueryAppContext");
    var NewItemCreatorDialog_1 = require("../dialog/NewItemCreatorDialog");
    function getProperties(inject, properties) {
        var formConfig = inject.datastoreData[0]
            ? Object.keys(inject.datastoreData[0]).map(function (fieldName) {
                return { field: fieldName };
            })
            : [];
        var isOpen = inject.dialogs.get(QueryAppContext_1.QueryAppDialogNames.addNewItemDialog).shown;
        var openDialog = function () { inject.dialogs.show(QueryAppContext_1.QueryAppDialogNames.addNewItemDialog); };
        var closeDialog = function () { inject.dialogs.hide(QueryAppContext_1.QueryAppDialogNames.addNewItemDialog); };
        return {
            formConfig: formConfig,
            onFormSubmit: inject.addNewItem.bind(inject),
            isOpen: isOpen,
            openDialog: openDialog,
            closeDialog: closeDialog
        };
    }
    var NewItemCreatorDialogContainer = Container_1.default(NewItemCreatorDialog_1.default, 'queryAppContext', { getProperties: getProperties });
    exports.default = NewItemCreatorDialogContainer;
});
//# sourceMappingURL=NewItemCreatorDialogContainer.js.map