(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../context/QueryAppContext", "../dialog/RowEditorDialog", "../common/MultiContextContainer"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var QueryAppContext_1 = require("../context/QueryAppContext");
    var RowEditorDialog_1 = require("../dialog/RowEditorDialog");
    var MultiContextContainer_1 = require("../common/MultiContextContainer");
    function getPropertiesFromQueryAppContext(inject, properties) {
        var formConfig = inject.datastoreData[0] ? Object.keys(inject.datastoreData[0]).map(function (fieldName) {
            return { field: fieldName };
        })
            : [];
        var item = inject.datastoreData[0] ?
            inject.datastoreData[inject.selectedGridRowIndex]
            : {};
        var isOpen = inject.dialogs.get(QueryAppContext_1.QueryAppDialogNames.editSelectedRowDialog).shown;
        var openDialog = function () { inject.dialogs.show(QueryAppContext_1.QueryAppDialogNames.editSelectedRowDialog); };
        var closeDialog = function () { inject.dialogs.hide(QueryAppContext_1.QueryAppDialogNames.editSelectedRowDialog); };
        return {
            formConfig: formConfig,
            onFormSubmit: inject.changeRowValue.bind(inject),
            item: item,
            isOpen: isOpen,
            openDialog: openDialog,
            closeDialog: closeDialog
        };
    }
    function getPropertiesFromGridContext(inject, properties) {
        var selectedRowIndex = inject.selectedRowIndex;
        return { selectedRowIndex: selectedRowIndex };
    }
    var RowEditorDialogContainer = MultiContextContainer_1.default(RowEditorDialog_1.default, {
        'queryAppContext': getPropertiesFromQueryAppContext,
        'gridContext': getPropertiesFromGridContext
    });
    exports.default = RowEditorDialogContainer;
});
//# sourceMappingURL=RowEditorDialogContainer.js.map