(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "@dojo/framework/widget-core/Container", "../../gridWidgets/grid/widgets/Cell"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var Container_1 = require("@dojo/framework/widget-core/Container");
    var Cell_1 = require("../../gridWidgets/grid/widgets/Cell");
    function getValueFromGridContext(context, rowIndex, columnIndex) {
        var rows = context.rowRows.rows;
        var row = rows[rowIndex];
        return String(row.cells[columnIndex].value);
    }
    function getProperties(inject, properties) {
        var rowIndex = properties.rowIndex, columnIndex = properties.columnIndex, key = properties.key;
        var value = getValueFromGridContext(inject, rowIndex, columnIndex);
        var _a = inject.rowFields.fieldsInfo[columnIndex], isEditable = _a.isEditable, minWidth = _a.minWidth;
        return {
            value: value,
            rowIndex: rowIndex,
            columnIndex: columnIndex,
            key: key,
            isEditable: isEditable,
            minWidth: minWidth
        };
    }
    var CellContainer = Container_1.Container(Cell_1.Cell, 'gridContext', { getProperties: getProperties });
    exports.default = CellContainer;
});
//# sourceMappingURL=CellContainer.js.map