(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "@dojo/framework/widget-core/Container", "../../gridWidgets/grid/widgets/editors/CellEditor"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var Container_1 = require("@dojo/framework/widget-core/Container");
    var CellEditor_1 = require("../../gridWidgets/grid/widgets/editors/CellEditor");
    function getValueFromGridContext(context, rowIndex, columnIndex) {
        var rows = context.rowRows.rows;
        var row = rows[rowIndex];
        return String(row.cells[columnIndex].value);
    }
    function getProperties(inject, properties) {
        var rowIndex = properties.rowIndex, columnIndex = properties.columnIndex, key = properties.key;
        var value = getValueFromGridContext(inject, rowIndex, columnIndex);
        var onCellValueUpdate = inject.changeCellValue.bind(inject);
        var onStopEditing = properties.onStopEditing;
        return {
            value: value,
            rowIndex: rowIndex,
            columnIndex: columnIndex,
            key: key,
            onCellValueUpdate: onCellValueUpdate,
            onStopEditing: onStopEditing
        };
    }
    var CellEditorContainer = Container_1.Container(CellEditor_1.default, 'gridContext', { getProperties: getProperties });
    exports.default = CellEditorContainer;
});
//# sourceMappingURL=CellEditorContainer.js.map