(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "@dojo/framework/widget-core/Container", "../../gridWidgets/grid/widgets/ColumnHeaderCell"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var Container_1 = require("@dojo/framework/widget-core/Container");
    var ColumnHeaderCell_1 = require("../../gridWidgets/grid/widgets/ColumnHeaderCell");
    function getValueFromGridContext(context, columnIndex) {
        var fields = context.rowFields.fieldsInfo;
        var field = fields[columnIndex];
        return field.label || field.name;
    }
    function getProperties(inject, properties) {
        var rowIndex = properties.rowIndex, columnIndex = properties.columnIndex;
        var value = getValueFromGridContext(inject, columnIndex);
        return {
            value: value,
            rowIndex: rowIndex,
            columnIndex: columnIndex
        };
    }
    var ColumnHeaderCellContainer = Container_1.default(ColumnHeaderCell_1.ColumnHeaderCell, 'gridContext', { getProperties: getProperties });
    exports.default = ColumnHeaderCellContainer;
});
//# sourceMappingURL=ColumnHeaderCellContainer.js.map