(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../../queryEditorInWrapper/QueryEditorContainerModal", "../../common/MultiContextContainer", "../../context/QueryAppContext"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var QueryEditorContainerModal_1 = require("../../queryEditorInWrapper/QueryEditorContainerModal");
    var MultiContextContainer_1 = require("../../common/MultiContextContainer");
    var QueryAppContext_1 = require("../../context/QueryAppContext");
    function getPropertiesFromAppContext(inject, properties) {
        var isOpen = inject.dialogs.get(QueryAppContext_1.QueryAppDialogNames.editQueryDialog).shown;
        var openDialog = function () { inject.dialogs.show(QueryAppContext_1.QueryAppDialogNames.editQueryDialog); };
        var closeDialog = function () { inject.dialogs.hide(QueryAppContext_1.QueryAppDialogNames.editQueryDialog); };
        return {
            isOpen: isOpen,
            openDialog: openDialog,
            closeDialog: closeDialog,
            query: inject.query,
            applyQuery: function (query) {
                inject.query = query;
                inject.reloadGridData();
            },
            fieldNames: inject.datastoreData[0]
                ? Object.keys(inject.datastoreData[0])
                : []
        };
    }
    function getPropertiesFromQueryEditorContext(inject, properties) {
        return {
            context: inject
        };
    }
    var QueryEditorContainerModalContainer = MultiContextContainer_1.default(QueryEditorContainerModal_1.default, {
        'queryAppContext': getPropertiesFromAppContext,
        'queryEditorContext': getPropertiesFromQueryEditorContext,
    });
    exports.default = QueryEditorContainerModalContainer;
});
//# sourceMappingURL=queryEditorContainerModalContainer.js.map