import { RowFields, RowRows } from '../common/interfaces';
export interface InitialGridState {
    fields?: RowFields;
    rows?: RowRows;
}
export default class GridContext {
    private _invalidator;
    private _rowFields;
    private _rowRows;
    private _changeDataItem;
    private _selectedRowIndex;
    constructor(invalidator: () => void, initialState: InitialGridState);
    rowFields: RowFields;
    rowRows: RowRows;
    changeDataItem: (rowIndex: number, columnIndex: number, value: string) => void;
    readonly selectedRowIndex: number;
    changeCellValue(rowIndex: number, columnIndex: number, value: string): void;
    selectRow(index: number): void;
}
