import Query from 'rollun-ts-rql/dist/Query';
import Limit from 'rollun-ts-rql/dist/nodes/Limit';
import AbstractQueryNode from 'rollun-ts-rql/dist/nodes/AbstractQueryNode';
import QueryAppContextInterface from './QueryAppContextInterface';
import GridContext from './GridContext';
import { FieldInfo, LoadingStatusEnum } from '../common/interfaces';
import DialogController from './DialogController';
export interface DataItem {
    id: number;
    value: string;
    isValid: boolean;
}
export declare enum QueryAppDialogNames {
    addNewItemDialog = "addNewItemDialog",
    editSelectedRowDialog = "editSelectedRowDialog",
    editQueryDialog = "editQueryDialog",
}
export default class QueryAppContext implements QueryAppContextInterface {
    private _invalidator;
    private _grid;
    private _queryManager;
    private _dataStoreDataUpdater;
    private _countDataUpdater;
    private _datastore;
    private _idArray;
    private _fieldsConfig;
    private _dialogs;
    constructor(invalidator: () => void, initialState: {
        datastoreUrl: string;
        grid: GridContext;
        fieldsConfig: FieldInfo[];
    });
    query: Query;
    grid: GridContext;
    readonly datastoreData: DataItem[];
    readonly countData: number;
    readonly datastoreDataLoadingStatus: LoadingStatusEnum;
    readonly countDataLoadingStatus: LoadingStatusEnum;
    readonly idArray: string[];
    readonly fieldsConfig: FieldInfo[];
    readonly selectedGridRowIndex: number;
    readonly dialogs: DialogController;
    reloadGridData(): void;
    setQueryLimit(limitNode: Limit): void;
    setQueryQuery(queryQuery: AbstractQueryNode): void;
    removeQueryQuery(): void;
    changeCellValue(rowIndex: number, columnIndex: number, value: string): void;
    changeRowValue(rowIndex: number, changedItem: any): void;
    addNewItem(item: any): void;
}
