import Query from 'rollun-ts-rql/dist/Query';
import Select from 'rollun-ts-rql/dist/nodes/Select';
import Sort from 'rollun-ts-rql/dist/nodes/Sort';
import AbstractQueryNode from 'rollun-ts-rql/dist/nodes/AbstractQueryNode';
import DialogController from './DialogController';
export declare enum QueryNodeNames {
    select = "select",
    sort = "sort",
    limit = "limit",
    query = "query",
}
export declare enum QueryEditorDialogNames {
    addNewNodeDialog = "addNewNodeDialog",
}
export default class QueryEditorContext {
    private _invalidator;
    private _onApplyQuery;
    private _fieldNames;
    private _query;
    private _dialogs;
    constructor(invalidator: () => void);
    onApplyQuery: (query: Query) => void;
    query: Query;
    fieldNames: string[];
    readonly dialogs: DialogController;
    applyQuery(query: Query): void;
    setQueryNode(node: AbstractQueryNode): void;
    setSelectNode(node: Select): void;
    setSortNode(node: Sort): void;
    removeNode(queryNodeName: QueryNodeNames): void;
    removeFieldFromNode(fieldName: string, nodeName: (QueryNodeNames.select | QueryNodeNames.sort)): void;
    getNodeForPath(path: number[]): AbstractQueryNode;
    hasNodeForPath(path: number[]): boolean;
    removeNodeForPath(path: number[]): void;
    addNodeForPath(node: AbstractQueryNode, path: number[]): void;
}
