(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "./AbstractDataUpdater", "../../queryManager/QueryManager"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var AbstractDataUpdater_1 = require("./AbstractDataUpdater");
    var QueryManager_1 = require("../../queryManager/QueryManager");
    var AbstractDatastoreDataUpdater = /** @class */ (function (_super) {
        tslib_1.__extends(AbstractDatastoreDataUpdater, _super);
        function AbstractDatastoreDataUpdater(datastore) {
            var _this = _super.call(this) || this;
            _this._datastore = datastore;
            _this._queryManager = new QueryManager_1.default();
            return _this;
        }
        Object.defineProperty(AbstractDatastoreDataUpdater.prototype, "query", {
            get: function () {
                return this._queryManager.getQuery();
            },
            set: function (query) {
                this._queryManager.setQuery(query);
            },
            enumerable: true,
            configurable: true
        });
        AbstractDatastoreDataUpdater.prototype._updateData = function () {
            var _this = this;
            return new Promise(function (resolve, reject) {
                _this._datastore.query(_this.getProcessedQuery()).then(function (data) {
                    resolve(data);
                }, function (error) {
                    reject(error);
                });
            });
        };
        return AbstractDatastoreDataUpdater;
    }(AbstractDataUpdater_1.default));
    exports.default = AbstractDatastoreDataUpdater;
});
//# sourceMappingURL=AbstractDatastoreDataUpdater.js.map