import WidgetBase from '@dojo/framework/widget-core/WidgetBase';
import { Constructor, DNode } from '@dojo/framework/widget-core/interfaces';
export interface EditorProps {
    value: string;
    onChange(newValue: string): void;
}
export interface FluidFormField {
    field: string;
    label?: string;
    editor?: Constructor<WidgetBase<EditorProps>>;
    validator?(value: string): {
        valid: boolean;
        message?: string;
    };
}
export interface FluidFormProps {
    formConfig: FluidFormField[];
    initialValues?: {
        [key: string]: string;
    };
    onFormSubmit(formData: {}): void;
}
export interface FormFieldMetadata {
    valid: boolean;
    message?: string;
}
export default class FluidForm extends WidgetBase<FluidFormProps> {
    private data;
    private metadata;
    private isStarted;
    protected render(): DNode;
    private getEditorForFormField(formField);
    protected getMessageForFormField(formField: any): DNode;
}
