(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@dojo/framework/widget-core/WidgetBase", "@dojo/framework/widget-core/d", "@dojo/widgets/text-input", "rollun-common/dist/css/bootstrap.m.css"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var WidgetBase_1 = require("@dojo/framework/widget-core/WidgetBase");
    var d_1 = require("@dojo/framework/widget-core/d");
    var text_input_1 = require("@dojo/widgets/text-input");
    var bs = require("rollun-common/dist/css/bootstrap.m.css");
    var FluidForm = /** @class */ (function (_super) {
        tslib_1.__extends(FluidForm, _super);
        function FluidForm() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.data = {};
            _this.metadata = {};
            return _this;
        }
        FluidForm.prototype.render = function () {
            var _this = this;
            if (!this.isStarted) {
                this.data = tslib_1.__assign({}, this.data, this.properties.initialValues);
                this.isStarted = true;
            }
            return d_1.v('div', { classes: bs.dFlex + " " + bs.flexColumn }, [
                d_1.v('form', {
                    classes: "" + bs.mb3
                }, this.properties.formConfig.map(function (formField) {
                    return d_1.v('div', {
                        classes: "" + bs.formGroup
                    }, [
                        d_1.v('div', {
                            classes: "" + bs.colFormLabel
                        }, [
                            formField.label || formField.field
                        ]),
                        _this.getEditorForFormField(formField),
                        _this.getMessageForFormField(formField),
                    ]);
                })),
                d_1.v('div', {
                    classes: bs.p3 + " " + bs.borderTop,
                    styles: { margin: '-1rem' }
                }, [
                    d_1.v('button', {
                        classes: bs.btn + "  " + bs.btnPrimary + " " + bs.btnBlock,
                        onclick: function () {
                            _this.properties.onFormSubmit(Object.assign({}, _this.data));
                            _this.data = {};
                        }
                    }, [
                        'Confirm'
                    ])
                ])
            ]);
        };
        FluidForm.prototype.getEditorForFormField = function (formField) {
            var _this = this;
            if (formField.editor) {
                return d_1.w(formField.editor, {
                    value: this.data[formField.field], onChange: function (value) {
                        _this.data[formField.field] = value;
                        if (formField.validator) {
                            _this.metadata[formField.field] = tslib_1.__assign({}, _this.metadata[formField.field], formField.validator(value));
                        }
                        else {
                            _this.metadata[formField.field] = { valid: true };
                        }
                        _this.invalidate();
                    }
                });
            }
            else {
                return d_1.w(text_input_1.default, {
                    extraClasses: {
                        input: "" + bs.formControl
                    },
                    invalid: (this.metadata[formField.field] && this.metadata[formField.field].valid === false),
                    value: this.data[formField.field],
                    onChange: function (value) {
                        _this.data[formField.field] = value;
                        if (formField.validator) {
                            _this.metadata[formField.field] = tslib_1.__assign({}, _this.metadata[formField.field], formField.validator(value));
                        }
                        else {
                            _this.metadata[formField.field] = { valid: true };
                        }
                        _this.invalidate();
                    }
                });
            }
        };
        FluidForm.prototype.getMessageForFormField = function (formField) {
            if (this.metadata[formField.field] && this.metadata[formField.field].message) {
                return d_1.v('div', {
                    classes: bs.p1 + " " + (this.metadata[formField.field].valid ? '' : bs.textDanger)
                }, [
                    this.metadata[formField.field].message
                ]);
            }
            return null;
        };
        return FluidForm;
    }(WidgetBase_1.default));
    exports.default = FluidForm;
});
//# sourceMappingURL=FluidForm.js.map