(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@dojo/framework/widget-core/WidgetBase", "../../../common/interfaces", "@dojo/framework/widget-core/d", "./ColumnHeaders", "./NoData", "rollun-common/dist/css/bootstrap.m.css", "../../../containers/grid/RowContainer", "lodash", "../../../context/GridContext", "./grid.m.css", "../../../common/ContextConfig"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var WidgetBase_1 = require("@dojo/framework/widget-core/WidgetBase");
    var interfaces_1 = require("../../../common/interfaces");
    var d_1 = require("@dojo/framework/widget-core/d");
    var ColumnHeaders_1 = require("./ColumnHeaders");
    var NoData_1 = require("./NoData");
    var bs = require("rollun-common/dist/css/bootstrap.m.css");
    var RowContainer_1 = require("../../../containers/grid/RowContainer");
    var lodash = require("lodash");
    var GridContext_1 = require("../../../context/GridContext");
    var ownCss = require("./grid.m.css");
    var ContextConfig_1 = require("../../../common/ContextConfig");
    var Grid = /** @class */ (function (_super) {
        tslib_1.__extends(Grid, _super);
        function Grid() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.isStarted = false;
            return _this;
        }
        Grid.prototype.render = function () {
            var fields = this.properties.fields;
            var rows = this.properties.rows;
            var gridComponents = [];
            if (!this.isStarted) {
                this.isStarted = true;
                this.properties.context.rowRows = this.properties.rows;
                this.properties.context.changeCellValue = this.properties.changeCellValue;
            }
            if (!lodash.isEqual(this.properties.context.rowFields, this.properties.fields)) { // ensure consistency between app data and grid data
                this.properties.context.rowFields = this.properties.fields;
            }
            if (!lodash.isEqual(this.properties.context.rowRows, this.properties.rows)) { // ensure consistency between app data and grid data
                this.properties.context.rowRows = this.properties.rows;
            }
            if (rows.rows && rows.rows.length > 0 && fields.fieldsInfo && fields.fieldsInfo.length > 0) { // if data is loaded
                gridComponents.push(d_1.w(ColumnHeaders_1.ColumnHeaders, { rowFields: fields }));
                rows.rows.forEach(function (item, rowIndex) {
                    gridComponents.push(d_1.w(RowContainer_1.default, { rowIndex: rowIndex, key: "row-" + rowIndex }));
                });
            }
            else {
                gridComponents.push(d_1.w(NoData_1.NoData, {}));
            }
            var classes = bs.border + " ";
            if (this.properties.loadingStatus === interfaces_1.LoadingStatusEnum.loading) {
                classes += ownCss.loading;
            }
            return d_1.v('div', { classes: bs.mw100 + " " + bs.overflowAuto }, [
                d_1.v('table', {
                    classes: classes,
                    styles: {
                        minWidth: '500px',
                        minHeight: '250px',
                    }
                }, gridComponents)
            ]);
        };
        Grid.contextConfig = new ContextConfig_1.default(GridContext_1.default, []);
        return Grid;
    }(WidgetBase_1.default));
    exports.Grid = Grid;
});
//# sourceMappingURL=Grid.js.map