(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@dojo/framework/widget-core/WidgetBase", "@dojo/framework/widget-core/d", "rollun-common/dist/css/bootstrap.m.css"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var WidgetBase_1 = require("@dojo/framework/widget-core/WidgetBase");
    var d_1 = require("@dojo/framework/widget-core/d");
    var bs = require("rollun-common/dist/css/bootstrap.m.css");
    var CellEditor = /** @class */ (function (_super) {
        tslib_1.__extends(CellEditor, _super);
        function CellEditor() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        CellEditor.prototype.onAttach = function () {
            var _this = this;
            document.onkeyup = function (event) {
                switch (event.code) {
                    case 'Enter':
                        _this.finishEditing();
                        break;
                    case 'Escape':
                        _this.cancelEditing();
                        break;
                }
            };
        };
        CellEditor.prototype.render = function () {
            var _this = this;
            if (!this.isStarted) {
                this.value = this.properties.value;
                this.isStarted = true;
            }
            return d_1.v('input', {
                type: 'text',
                classes: "" + bs.w100,
                value: this.value,
                focus: function () { return true; },
                oninput: function (event) {
                    // @ts-ignore
                    _this.value = event.target.value;
                    _this.invalidate();
                },
                onblur: function () {
                    _this.finishEditing();
                }
            });
        };
        CellEditor.prototype.finishEditing = function () {
            var _a = this.properties, rowIndex = _a.rowIndex, columnIndex = _a.columnIndex;
            this.properties.onCellValueUpdate(rowIndex, columnIndex, this.value);
            this.properties.onStopEditing();
        };
        CellEditor.prototype.cancelEditing = function () {
            this.properties.onStopEditing();
        };
        CellEditor.prototype.onDetach = function () {
            delete document.onkeyup;
        };
        return CellEditor;
    }(WidgetBase_1.default));
    exports.default = CellEditor;
});
//# sourceMappingURL=CellEditor.js.map