(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@dojo/framework/widget-core/WidgetBase", "@dojo/framework/widget-core/d", "@dojo/widgets/text-input", "rollun-common/dist/css/bootstrap.m.css", "rollun-common/dist/css/fontawesome.m.css", "rollun-common/dist/css/solid.m.css", "./rowEditor.m.css"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var WidgetBase_1 = require("@dojo/framework/widget-core/WidgetBase");
    var d_1 = require("@dojo/framework/widget-core/d");
    var text_input_1 = require("@dojo/widgets/text-input");
    var bs = require("rollun-common/dist/css/bootstrap.m.css");
    var fa = require("rollun-common/dist/css/fontawesome.m.css");
    var faSolid = require("rollun-common/dist/css/solid.m.css");
    var ownCss = require("./rowEditor.m.css");
    var RowEditor = /** @class */ (function (_super) {
        tslib_1.__extends(RowEditor, _super);
        function RowEditor() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.isStarted = false;
            _this.state = {};
            return _this;
        }
        RowEditor.prototype.render = function () {
            var _this = this;
            var _a = this.properties, rowFields = _a.rowFields, rowCells = _a.rowCells;
            if (!this.isStarted) {
                this.state = rowCells;
                if (document.onkeyup) { // FIXME: implement open editor managing
                    document.onkeyup(new KeyboardEvent('keyup', { code: 'Escape' }));
                }
                this.isStarted = true;
            }
            document.onkeyup = function (event) {
                switch (event.code) {
                    case 'Enter':
                        _this.finishEditing();
                        break;
                    case 'Escape':
                        _this.cancelEditing();
                        break;
                }
            };
            return tslib_1.__spread([
                d_1.v('button', {
                    classes: bs.btn + "  " + bs.btnSuccess + " " + bs.btnSm + " " + bs.positionRelative + "  " + bs.floatLeft + " " + ownCss.controlBtn,
                    onclick: function () {
                        _this.finishEditing();
                    }
                }, [
                    d_1.v('i', { classes: faSolid.fas + " " + fa.faCheck + " " })
                ]),
                d_1.v('button', {
                    classes: bs.btn + " " + bs.btnDanger + " " + bs.btnSm + " " + bs.positionRelative + "  " + bs.floatLeft + " " + ownCss.controlBtn,
                    onclick: function () {
                        _this.cancelEditing();
                    }
                }, [
                    d_1.v('i', { classes: faSolid.fas + " " + fa.faBan })
                ])
            ], rowFields.fieldsInfo.map(function (fieldInfo) {
                return _this.renderEditor(fieldInfo, _this.state[fieldInfo.name]);
            }));
        };
        RowEditor.prototype.finishEditing = function () {
            var newItem = Object.assign({}, this.state);
            this.properties.onItemUpdate(newItem);
            document.onkeyup = function () {
            };
        };
        RowEditor.prototype.cancelEditing = function () {
            this.properties.onUpdateCancel();
            document.onkeyup = function () {
            };
        };
        RowEditor.prototype.renderEditor = function (fieldInfo, value) {
            var _this = this;
            return d_1.v('div', { classes: bs.dFlex + " " + bs.p1 + "  " + bs.flexGrow1 }, [
                d_1.w(text_input_1.default, {
                    extraClasses: {
                        root: "" + bs.w100,
                        inputWrapper: "" + bs.w100,
                        input: "" + bs.w100,
                    },
                    value: value,
                    onInput: function (value) {
                        _this.state[fieldInfo.name] = value;
                        _this.invalidate();
                    }
                })
            ]);
        };
        return RowEditor;
    }(WidgetBase_1.default));
    exports.default = RowEditor;
});
//# sourceMappingURL=RowEditor.js.map