(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@dojo/framework/widget-core/WidgetBase", "@dojo/framework/widget-core/d", "rollun-common/dist/css/bootstrap.m.css", "../../../../containers/grid/CellContainer"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var WidgetBase_1 = require("@dojo/framework/widget-core/WidgetBase");
    var d_1 = require("@dojo/framework/widget-core/d");
    var bs = require("rollun-common/dist/css/bootstrap.m.css");
    var CellContainer_1 = require("../../../../containers/grid/CellContainer");
    var Row = /** @class */ (function (_super) {
        tslib_1.__extends(Row, _super);
        function Row() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Row.prototype.render = function () {
            return this.basicRender();
        };
        Row.prototype.basicRender = function () {
            var _a = this.properties, rowFields = _a.rowFields, rowIndex = _a.rowIndex;
            return d_1.v('tr', this.getRowNodeProperties(), rowFields.fieldsInfo.map(function (fieldInfo, columnIndex) {
                return d_1.w(CellContainer_1.default, { rowIndex: rowIndex, columnIndex: columnIndex, key: "cell-" + rowIndex + "-" + columnIndex });
            }));
        };
        Row.prototype.getRowNodeProperties = function () {
            var _this = this;
            var isSelected = this.properties.isSelected;
            var properties = {
                classes: bs.borderBottom + " " + (isSelected ? bs.bgLight : ''),
                onclick: function () {
                    if (!isSelected) {
                        _this.properties.onSelect();
                    }
                }
            };
            return properties;
        };
        return Row;
    }(WidgetBase_1.default));
    exports.Row = Row;
});
//# sourceMappingURL=Row.js.map