(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@dojo/framework/widget-core/WidgetBase", "@dojo/framework/widget-core/d", "../../common/interfaces", "rollun-ts-rql/dist/nodes/scalarNodes/Alike", "rollun-ts-rql/dist/nodes/logicalNodes/Or", "rollun-common/dist/css/bootstrap.m.css", "rollun-common/dist/css/fontawesome.m.css", "rollun-common/dist/css/solid.m.css", "./searchBar.m.css"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var WidgetBase_1 = require("@dojo/framework/widget-core/WidgetBase");
    var d_1 = require("@dojo/framework/widget-core/d");
    var interfaces_1 = require("../../common/interfaces");
    var Alike_1 = require("rollun-ts-rql/dist/nodes/scalarNodes/Alike");
    var Or_1 = require("rollun-ts-rql/dist/nodes/logicalNodes/Or");
    var bs = require("rollun-common/dist/css/bootstrap.m.css");
    var fa = require("rollun-common/dist/css/fontawesome.m.css");
    var faSolid = require("rollun-common/dist/css/solid.m.css");
    var ownCss = require("./searchBar.m.css");
    var SearchBar = /** @class */ (function (_super) {
        tslib_1.__extends(SearchBar, _super);
        function SearchBar() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.searchValue = '';
            _this.searchIsApplied = false;
            _this.rowFields = { fieldsInfo: [] };
            return _this;
        }
        SearchBar.prototype.render = function () {
            var _this = this;
            if (this.properties.rowFields.fieldsInfo.length > this.rowFields.fieldsInfo.length) {
                this.rowFields = this.properties.rowFields;
            }
            var isLoading = this.properties.loadingStatus === interfaces_1.LoadingStatusEnum.loading;
            var rootNodeClasses = bs.dFlex + " " + bs.flexRow + " " + bs.mx1;
            if (isLoading) {
                rootNodeClasses += ownCss.loading;
            }
            return d_1.v('div', { classes: rootNodeClasses }, [
                d_1.v('div', {}, [
                    d_1.v('input', {
                        styles: {
                            minWidth: '150px',
                        },
                        disabled: isLoading,
                        type: 'text',
                        classes: bs.formControl + " " + bs.formControlSm,
                        placeholder: 'Search in table',
                        value: this.searchValue,
                        onchange: function (event) {
                            // @ts-ignore
                            _this.searchValue = event.target.value;
                            _this.invalidate();
                        }
                    })
                ]),
                d_1.v('div', {}, [
                    d_1.v('button', {
                        classes: bs.btn + "  " + bs.btnSm + " " + bs.btnDanger,
                        disabled: (!this.searchIsApplied || isLoading),
                        onclick: function () {
                            _this.cancelSearch();
                        }
                    }, [
                        d_1.v('i', { classes: faSolid.fas + " " + fa.faBan })
                    ])
                ]),
                d_1.v('div', {}, [
                    d_1.v('button', {
                        classes: bs.btn + " " + bs.btnSm + " " + bs.btnPrimary,
                        disabled: isLoading,
                        onclick: function () {
                            _this.search(_this.searchValue);
                        }
                    }, [
                        d_1.v('i', { classes: faSolid.fas + " " + fa.faSearch })
                    ]),
                ]),
            ]);
        };
        SearchBar.prototype.search = function (value) {
            var searchNodesArray = [];
            this.rowFields.fieldsInfo.forEach(function (fieldInfo) {
                searchNodesArray.push(new Alike_1.default(fieldInfo.name, value));
            });
            this.searchIsApplied = true;
            this.properties.setFilterNode(new Or_1.default(searchNodesArray));
        };
        SearchBar.prototype.cancelSearch = function () {
            this.properties.cancelSearch();
            this.searchIsApplied = false;
            this.searchValue = '';
            this.invalidate();
        };
        return SearchBar;
    }(WidgetBase_1.default));
    exports.default = SearchBar;
});
//# sourceMappingURL=SearchBar.js.map