(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@dojo/framework/widget-core/WidgetBase", "@dojo/framework/widget-core/d", "@dojo/widgets/text-input", "./limitNode.m.css", "rollun-common/dist/css/bootstrap.m.css"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var WidgetBase_1 = require("@dojo/framework/widget-core/WidgetBase");
    var d_1 = require("@dojo/framework/widget-core/d");
    var text_input_1 = require("@dojo/widgets/text-input");
    var css = require("./limitNode.m.css");
    var bs = require("rollun-common/dist/css/bootstrap.m.css");
    var LimitNodeEditor = /** @class */ (function (_super) {
        tslib_1.__extends(LimitNodeEditor, _super);
        function LimitNodeEditor() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        LimitNodeEditor.prototype.render = function () {
            var _this = this;
            return d_1.v('div', { classes: bs.dFlex + " " + bs.p2 + " " + bs.flexColumn + " " + css.root }, [
                d_1.v('div', { classes: bs.dFlex + " " + bs.flexRow + " " + css.titleRow }, [
                    d_1.v('span', {}, ['Limit node']),
                    d_1.v('button', {
                        classes: bs.btn + " " + bs.btnSm + " " + bs.btnDanger,
                        onclick: function () {
                            _this.properties.onRemove();
                        }
                    }, ['X'])
                ]),
                d_1.v('div', { classes: bs.dFlex + " " + bs.flexColumn + " " + css.editorsContainer }, [
                    d_1.v('div', { classes: bs.dFlex + " " + bs.flexRow + " " + css.limitEditorRow }, [
                        d_1.v('div', { classes: bs.mr2 + " " + css.editorItem }, ['Limit']),
                        d_1.w(text_input_1.default, {
                            type: 'number',
                            value: String(this.properties.node.limit),
                            onChange: function (value) {
                                _this.properties.node.limit = value;
                                _this.invalidate();
                            }
                        })
                    ]),
                    d_1.v('div', { classes: bs.dFlex + " " + bs.flexRow + " " + css.limitEditorRow }, [
                        d_1.v('div', { classes: bs.mr2 + " " + css.editorItem }, ['Offset']),
                        d_1.w(text_input_1.default, {
                            type: 'number',
                            value: String(this.properties.node.offset),
                            onChange: function (value) {
                                _this.properties.node.offset = value;
                                _this.invalidate();
                            }
                        })
                    ])
                ])
            ]);
        };
        return LimitNodeEditor;
    }(WidgetBase_1.default));
    exports.default = LimitNodeEditor;
});
//# sourceMappingURL=LimitNodeEditor.js.map