(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@dojo/framework/widget-core/WidgetBase", "@dojo/framework/widget-core/d", "rollun-ts-rql/dist/nodes/Select", "rollun-ts-rql/dist/nodes/Sort", "../selectNodeEditor/SelectNodeEditor", "../sortNodeEditor/SortNodeEditor", "../dropToRemoveNodeField/DropToRemoveNodeField", "../possibleNodeFields/PossibleNodeFields", "rollun-ts-rql/dist/nodes/logicalNodes/AbstractLogicalNode", "../queryQueryEditor/logicalEditor/ChildNodeCreationForm", "../../rqlNodeFactory/RqlNodeFactory", "rollun-ts-rql/dist/nodes/scalarNodes/AbstractScalarNode", "rollun-ts-rql/dist/nodes/arrayNodes/AbstractArrayNode", "rollun-common/dist/css/bootstrap.m.css", "./queryEditor.m.css", "../../dialog/Dialog", "../../context/QueryEditorContext", "../../containers/queryBuilder/arrayNodeEditorContainer", "../../containers/queryBuilder/scalarNodeEditorContainer", "../../containers/queryBuilder/logicalNodeEditorContainer", "../../common/ContextConfig"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var WidgetBase_1 = require("@dojo/framework/widget-core/WidgetBase");
    var d_1 = require("@dojo/framework/widget-core/d");
    var Select_1 = require("rollun-ts-rql/dist/nodes/Select");
    var Sort_1 = require("rollun-ts-rql/dist/nodes/Sort");
    var SelectNodeEditor_1 = require("../selectNodeEditor/SelectNodeEditor");
    var SortNodeEditor_1 = require("../sortNodeEditor/SortNodeEditor");
    var DropToRemoveNodeField_1 = require("../dropToRemoveNodeField/DropToRemoveNodeField");
    var PossibleNodeFields_1 = require("../possibleNodeFields/PossibleNodeFields");
    var AbstractLogicalNode_1 = require("rollun-ts-rql/dist/nodes/logicalNodes/AbstractLogicalNode");
    var ChildNodeCreationForm_1 = require("../queryQueryEditor/logicalEditor/ChildNodeCreationForm");
    var RqlNodeFactory_1 = require("../../rqlNodeFactory/RqlNodeFactory");
    var AbstractScalarNode_1 = require("rollun-ts-rql/dist/nodes/scalarNodes/AbstractScalarNode");
    var AbstractArrayNode_1 = require("rollun-ts-rql/dist/nodes/arrayNodes/AbstractArrayNode");
    var bs = require("rollun-common/dist/css/bootstrap.m.css");
    var ownCss = require("./queryEditor.m.css");
    var Dialog_1 = require("../../dialog/Dialog");
    var QueryEditorContext_1 = require("../../context/QueryEditorContext");
    var arrayNodeEditorContainer_1 = require("../../containers/queryBuilder/arrayNodeEditorContainer");
    var scalarNodeEditorContainer_1 = require("../../containers/queryBuilder/scalarNodeEditorContainer");
    var logicalNodeEditorContainer_1 = require("../../containers/queryBuilder/logicalNodeEditorContainer");
    var ContextConfig_1 = require("../../common/ContextConfig");
    var QueryEditor = /** @class */ (function (_super) {
        tslib_1.__extends(QueryEditor, _super);
        function QueryEditor() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.openQueryCreationDialog = false;
            _this.rqlNodeFactory = new RqlNodeFactory_1.default();
            return _this;
        }
        QueryEditor.prototype.render = function () {
            var _this = this;
            if (!this.isStarted) {
                this.context = this.properties.context;
                this.context.query = this.properties.query;
                this.isStarted = true;
            }
            var nonQueryEditors = [
                d_1.v('div', { classes: bs.colMd4 + " " + bs.p0 }, [
                    d_1.w(PossibleNodeFields_1.default, { fieldNames: this.context.fieldNames })
                ]),
                d_1.v('div', { classes: bs.colMd3 + " " + bs.p0 }, [
                    this.renderSelectNode(this.context.query.selectNode)
                ]),
                d_1.v('div', { classes: bs.colMd3 + " " + bs.p0 }, [
                    this.renderSortNode(this.context.query.sortNode)
                ]),
                d_1.v('div', { classes: bs.colMd2 + " " + bs.p0 }, [
                    d_1.w(DropToRemoveNodeField_1.default, {
                        onNodeFieldRemove: function (fieldName, nodeType) {
                            _this.removeFieldFromNode(fieldName, nodeType);
                        }
                    })
                ])
            ];
            return d_1.v('div', {
                classes: bs.dFlex + " " + bs.flexColumn + " " + bs.mb3 + " " + bs.w100
            }, [
                d_1.v('div', {
                    classes: bs.dFlex + " " + bs.flexRow + " " + bs.mb2 + " " + bs.m0 + " " + bs.row + " " + bs.w100 + " " + ownCss.nonQueryEditors,
                }, nonQueryEditors),
                d_1.v('div', { classes: bs.dFlex + " " + bs.justifyContentCenter + " " + bs.mb1 }, this.renderQueryNode(this.context.query.queryNode))
            ]);
        };
        QueryEditor.prototype.renderSelectNode = function (node) {
            var _this = this;
            if (node) {
                var onRemove = function () {
                    _this.removeNode('select');
                };
                var onSelectNodeChange = function (fields) {
                    _this.context.setSelectNode(new Select_1.default(fields));
                };
                return d_1.w(SelectNodeEditor_1.default, {
                    node: node, onRemove: onRemove, fieldNames: this.context.fieldNames, onSelectNodeChange: onSelectNodeChange
                });
            }
            else {
                return d_1.v('div', {
                    classes: bs.dFlex + " " + bs.justifyContentCenter + " " + bs.alignItemsCenter + " " + bs.h100
                }, [
                    d_1.v('button', {
                        classes: bs.btn + " " + bs.btnLg + " " + bs.btnLight + " " + bs.mb1,
                        onclick: function () {
                            _this.context.setSelectNode(new Select_1.default(['id']));
                        }
                    }, ['Add select node'])
                ]);
            }
        };
        QueryEditor.prototype.renderSortNode = function (node) {
            var _this = this;
            if (node) {
                var onSortNodeChange = function (sortOptions) {
                    _this.context.setSortNode(new Sort_1.default(sortOptions));
                    _this.invalidate();
                };
                var onRemove = function () {
                    _this.removeNode('sort');
                };
                return d_1.w(SortNodeEditor_1.default, { node: node, onRemove: onRemove, onSortNodeChange: onSortNodeChange });
            }
            else {
                return d_1.v('div', {
                    classes: bs.dFlex + " " + bs.justifyContentCenter + " " + bs.alignItemsCenter + " " + bs.h100
                }, [
                    d_1.v('button', {
                        classes: bs.btn + " " + bs.btnLg + " " + bs.btnLight + "  " + bs.mb1,
                        onclick: function () {
                            _this.context.setSortNode(new Sort_1.default({ id: 1 }));
                        }
                    }, ['Add sort node'])
                ]);
            }
        };
        QueryEditor.prototype.renderQueryNode = function (node) {
            var _this = this;
            if (node) {
                var path = [0];
                var key = "query-" + path[0];
                switch (true) {
                    case node instanceof AbstractLogicalNode_1.default:
                        return [
                            d_1.w(logicalNodeEditorContainer_1.default, {
                                path: path,
                                key: key
                            })
                        ];
                    case node instanceof AbstractScalarNode_1.default:
                        return [
                            d_1.w(scalarNodeEditorContainer_1.default, {
                                path: path,
                                key: key
                            })
                        ];
                    case node instanceof AbstractArrayNode_1.default:
                        return [
                            d_1.w(arrayNodeEditorContainer_1.default, {
                                path: path,
                                key: key
                            })
                        ];
                }
            }
            else {
                return [
                    d_1.v('button', {
                        classes: bs.btn + " " + bs.btnLg + " " + bs.btnLight,
                        onclick: function () {
                            _this.openQueryCreationDialog = true;
                            _this.invalidate();
                        }
                    }, ['Add query node']),
                    d_1.w(Dialog_1.default, {
                        title: 'Create new node',
                        isOpen: this.openQueryCreationDialog,
                        onClose: function () {
                            _this.openQueryCreationDialog = false;
                            _this.invalidate();
                        },
                        options: {
                            centered: true
                        }
                    }, [
                        d_1.w(ChildNodeCreationForm_1.default, {
                            onChildNodeCreate: function (nodeName, params) {
                                _this.openQueryCreationDialog = false;
                                _this.context.setQueryNode(_this.rqlNodeFactory.createNode(nodeName, params));
                            },
                            fieldNames: this.properties.fieldNames
                        })
                    ])
                ];
            }
        };
        QueryEditor.prototype.removeNode = function (queryNodeName) {
            switch (true) {
                case queryNodeName === 'select': {
                    this.context.removeNode(QueryEditorContext_1.QueryNodeNames.select);
                    break;
                }
                case queryNodeName === 'sort': {
                    this.context.removeNode(QueryEditorContext_1.QueryNodeNames.sort);
                    break;
                }
                case queryNodeName === 'limit': {
                    this.context.removeNode(QueryEditorContext_1.QueryNodeNames.limit);
                    break;
                }
                case queryNodeName === 'query': {
                    this.context.removeNode(QueryEditorContext_1.QueryNodeNames.query);
                    break;
                }
            }
        };
        QueryEditor.prototype.removeFieldFromNode = function (fieldName, nodeType) {
            switch (nodeType) {
                case 'selectnode':
                    var fieldNameIndex = this.context.query.selectNode.fields.indexOf(fieldName);
                    if (fieldNameIndex !== -1) {
                        this.context.query.selectNode.fields.splice(fieldNameIndex, 1);
                        var newFields = tslib_1.__spread(this.context.query.selectNode.fields);
                        this.context.setSelectNode(new Select_1.default(newFields));
                    }
                    break;
                case 'sortnode':
                    if (this.context.query.sortNode.sortOptions.hasOwnProperty(fieldName)) {
                        delete this.context.query.sortNode.sortOptions[fieldName];
                        var newSortOptions = Object.assign({}, this.context.query.sortNode.sortOptions);
                        this.context.setSortNode(new Sort_1.default(newSortOptions));
                    }
                    break;
            }
        };
        QueryEditor.contextConfig = new ContextConfig_1.default(QueryEditorContext_1.default, []);
        return QueryEditor;
    }(WidgetBase_1.default));
    exports.default = QueryEditor;
});
//# sourceMappingURL=QueryEditor.js.map