(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@dojo/framework/widget-core/WidgetBase", "@dojo/framework/widget-core/d", "rollun-ts-rql/dist/nodes/logicalNodes/AbstractLogicalNode", "rollun-ts-rql/dist/nodes/scalarNodes/AbstractScalarNode", "rollun-ts-rql/dist/nodes/arrayNodes/AbstractArrayNode", "../../../rqlNodeFactory/RqlNodeFactory", "rollun-common/dist/css/bootstrap.m.css", "rollun-common/dist/css/fontawesome.m.css", "rollun-common/dist/css/solid.m.css", "./logicalNode.m.css", "../../../containers/queryBuilder/scalarNodeEditorContainer", "../../../containers/queryBuilder/logicalNodeEditorContainer", "../../../containers/queryBuilder/arrayNodeEditorContainer", "@dojo/framework/widget-core/decorators/diffProperty", "../../../common/functions", "../../../containers/queryBuilder/childNodeCreationFormDialogContainer"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var WidgetBase_1 = require("@dojo/framework/widget-core/WidgetBase");
    var d_1 = require("@dojo/framework/widget-core/d");
    var AbstractLogicalNode_1 = require("rollun-ts-rql/dist/nodes/logicalNodes/AbstractLogicalNode");
    var AbstractScalarNode_1 = require("rollun-ts-rql/dist/nodes/scalarNodes/AbstractScalarNode");
    var AbstractArrayNode_1 = require("rollun-ts-rql/dist/nodes/arrayNodes/AbstractArrayNode");
    var RqlNodeFactory_1 = require("../../../rqlNodeFactory/RqlNodeFactory");
    var bs = require("rollun-common/dist/css/bootstrap.m.css");
    var fa = require("rollun-common/dist/css/fontawesome.m.css");
    var faSolid = require("rollun-common/dist/css/solid.m.css");
    var css = require("./logicalNode.m.css");
    var scalarNodeEditorContainer_1 = require("../../../containers/queryBuilder/scalarNodeEditorContainer");
    var logicalNodeEditorContainer_1 = require("../../../containers/queryBuilder/logicalNodeEditorContainer");
    var arrayNodeEditorContainer_1 = require("../../../containers/queryBuilder/arrayNodeEditorContainer");
    var diffProperty_1 = require("@dojo/framework/widget-core/decorators/diffProperty");
    var functions_1 = require("../../../common/functions");
    var childNodeCreationFormDialogContainer_1 = require("../../../containers/queryBuilder/childNodeCreationFormDialogContainer");
    var LogicalNodeEditor = /** @class */ (function (_super) {
        tslib_1.__extends(LogicalNodeEditor, _super);
        function LogicalNodeEditor() {
            var _this = _super.call(this) || this;
            _this.nodeFactory = new RqlNodeFactory_1.default();
            return _this;
        }
        LogicalNodeEditor.prototype.render = function () {
            var _this = this;
            return d_1.v('div', { classes: bs.dFlex + " " + bs.flexColumn + " " + css.root }, [
                d_1.v('div', { classes: bs.dFlex + " " + bs.flexRow + " " + bs.bgInfo + " " + bs.textWhite + " " + bs.p1 + " " + css.controls }, [
                    d_1.v('div', { classes: bs.dFlex + " " + bs.justifyContentStart + " " + css.titleContainer }, [
                        d_1.v('div', { classes: bs.m1 + " " + css.title }, [this.getNodeName()])
                    ]),
                    d_1.v('div', { classes: bs.dFlex + " " + bs.justifyContentEnd + " " + css.controlsButtonsContainer }, [
                        d_1.v('div', { classes: css.controlsButtons }, [
                            d_1.v('button', {
                                classes: bs.btn + " " + bs.btnLight + " " + bs.btnSm + " " + bs.mx2,
                                onclick: function () {
                                    _this.addChildNode();
                                }
                            }, [
                                d_1.v('i', { classes: faSolid.fas + " " + fa.faPlus })
                            ]),
                            d_1.v('button', {
                                classes: bs.btn + " " + bs.btnDanger + " " + bs.btnSm,
                                onclick: function () {
                                    _this.properties.onRemove(_this.properties.path);
                                }
                            }, [
                                d_1.v('i', { classes: faSolid.fas + " " + fa.faTimes })
                            ])
                        ])
                    ])
                ]),
                d_1.v('div', { classes: bs.dFlex + " " + bs.flexColumn + " " + bs.p2 + " " + css.childNodesContainer }, this.properties.node.subNodes.map(function (node, index) {
                    var currentChildPath = _this.properties.path.concat([index]);
                    var key = "query-" + currentChildPath.join('-');
                    switch (true) {
                        case (node instanceof AbstractLogicalNode_1.default):
                            return d_1.w(logicalNodeEditorContainer_1.default, {
                                path: currentChildPath,
                                key: key,
                            });
                        case (node instanceof AbstractScalarNode_1.default):
                            return d_1.w(scalarNodeEditorContainer_1.default, {
                                path: currentChildPath,
                                key: key
                            });
                        case (node instanceof AbstractArrayNode_1.default):
                            return d_1.w(arrayNodeEditorContainer_1.default, {
                                path: currentChildPath,
                                key: key
                            });
                    }
                })),
                d_1.w(childNodeCreationFormDialogContainer_1.default, { onChildNodeCreate: this.createChildNode.bind(this) })
            ]);
        };
        LogicalNodeEditor.prototype.getNodeName = function () {
            return d_1.v('div', {}, [this.properties.node.name]);
        };
        LogicalNodeEditor.prototype.addChildNode = function () {
            this.properties.openDialog();
        };
        LogicalNodeEditor.prototype.createChildNode = function (nodeName, params) {
            this.properties.onAddChildNode(this.nodeFactory.createNode(nodeName, params));
            this.invalidate();
        };
        tslib_1.__decorate([
            diffProperty_1.default('node', functions_1.undefinedSafeDiffNode),
            tslib_1.__metadata("design:type", Function),
            tslib_1.__metadata("design:paramtypes", []),
            tslib_1.__metadata("design:returntype", Object)
        ], LogicalNodeEditor.prototype, "render", null);
        return LogicalNodeEditor;
    }(WidgetBase_1.default));
    exports.default = LogicalNodeEditor;
});
//# sourceMappingURL=LogicalNodeEditor.js.map