(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@dojo/framework/widget-core/WidgetBase", "@dojo/framework/widget-core/d", "./scalarNode.m.css", "rollun-common/dist/css/bootstrap.m.css", "rollun-common/dist/css/fontawesome.m.css", "rollun-common/dist/css/solid.m.css", "@dojo/framework/widget-core/decorators/diffProperty", "../../../common/functions"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var WidgetBase_1 = require("@dojo/framework/widget-core/WidgetBase");
    var d_1 = require("@dojo/framework/widget-core/d");
    var ownCss = require("./scalarNode.m.css");
    var bootstrap = require("rollun-common/dist/css/bootstrap.m.css");
    var fa = require("rollun-common/dist/css/fontawesome.m.css");
    var faSolid = require("rollun-common/dist/css/solid.m.css");
    var diffProperty_1 = require("@dojo/framework/widget-core/decorators/diffProperty");
    var functions_1 = require("../../../common/functions");
    var ScalarNodeEditor = /** @class */ (function (_super) {
        tslib_1.__extends(ScalarNodeEditor, _super);
        function ScalarNodeEditor() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ScalarNodeEditor.prototype.render = function () {
            var _this = this;
            return d_1.v('div', { classes: ownCss.root }, [
                d_1.v('div', { classes: bootstrap.dFlex + " " + bootstrap.flexRow + " " + ownCss.controlsContainer }, [
                    d_1.v('select', {
                        classes: 'bootstrap.customSelect',
                        onChange: function (event) {
                            // @ts-ignore
                            _this.properties.node.fieldName = event.target.value;
                        }
                    }, this.properties.fieldNames.map(function (nodeName) { return d_1.v('option', { value: nodeName, selected: nodeName === _this.properties.node.name }, [nodeName]); })),
                    d_1.v('div', { classes: bootstrap.px3 + " " + bootstrap.py1 + " " + bootstrap.dFlex + " " + bootstrap.alignItemsCenter }, [this.getHumanNodeName(this.properties.node.name)]),
                    d_1.v('input', {
                        type: 'text',
                        classes: '${bootstrap.formControl}',
                        value: this.properties.node.value,
                        onchange: function (event) {
                            // @ts-ignore
                            _this.properties.node.value = event.target.value;
                            _this.invalidate();
                        }
                    }),
                ]),
                d_1.v('div', { classes: bootstrap.dFlex + " " + bootstrap.flexRowReverse + " " + ownCss.closeBtnContainer }, [
                    d_1.v('button', {
                        classes: ownCss.removeButton + " " + bootstrap.btn + " " + bootstrap.btnSm + " " + bootstrap.btnDanger,
                        onclick: function () {
                            _this.removeSelf();
                        }
                    }, [
                        d_1.v('i', { classes: faSolid.fas + " " + fa.faTimes })
                    ])
                ])
            ]);
        };
        ScalarNodeEditor.prototype.removeSelf = function () {
            this.properties.onRemove(this.properties.path);
        };
        ScalarNodeEditor.prototype.getHumanNodeName = function (nodeName) {
            return nodeName;
        };
        tslib_1.__decorate([
            diffProperty_1.default('node', functions_1.undefinedSafeDiffNode),
            tslib_1.__metadata("design:type", Function),
            tslib_1.__metadata("design:paramtypes", []),
            tslib_1.__metadata("design:returntype", Object)
        ], ScalarNodeEditor.prototype, "render", null);
        return ScalarNodeEditor;
    }(WidgetBase_1.default));
    exports.default = ScalarNodeEditor;
});
//# sourceMappingURL=ScalarNodeEditor.js.map