(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@dojo/framework/widget-core/WidgetBase", "@dojo/framework/widget-core/d", "rollun-ts-rql/dist/Query", "rollun-ts-rql/dist/nodes/Limit", "rollun-common/dist/css/bootstrap.m.css", "../dialog/Dialog", "../containers/queryBuilder/queryEditorContainerModalContainer"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var WidgetBase_1 = require("@dojo/framework/widget-core/WidgetBase");
    var d_1 = require("@dojo/framework/widget-core/d");
    var Query_1 = require("rollun-ts-rql/dist/Query");
    var Limit_1 = require("rollun-ts-rql/dist/nodes/Limit");
    var bs = require("rollun-common/dist/css/bootstrap.m.css");
    var Dialog_1 = require("../dialog/Dialog");
    var queryEditorContainerModalContainer_1 = require("../containers/queryBuilder/queryEditorContainerModalContainer");
    var QueryEditorModal = /** @class */ (function (_super) {
        tslib_1.__extends(QueryEditorModal, _super);
        function QueryEditorModal() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.openDialog = false;
            _this.query = new Query_1.default({ limit: new Limit_1.default(20, 0) });
            _this.isStarted = false;
            return _this;
        }
        QueryEditorModal.prototype.render = function () {
            var _this = this;
            var _a = this.properties, fieldNames = _a.fieldNames, applyQuery = _a.applyQuery;
            if (!this.isStarted && fieldNames && fieldNames.length > 0) {
                this.fieldNames = fieldNames;
                this.isStarted = true;
            }
            return d_1.v('div', {
                styles: {}
            }, [
                d_1.w(Dialog_1.default, {
                    title: 'Edit query',
                    isOpen: this.openDialog,
                    onClose: function () {
                        _this.openDialog = false;
                        _this.invalidate();
                    },
                    options: {
                        size: 3,
                        centered: true
                    }
                }, [
                    d_1.v('div', {
                        classes: bs.dFlex + " " + bs.flexGrow1
                    }, [
                        // @ts-ignore
                        d_1.w(queryEditorContainerModalContainer_1.default, { fieldNames: this.fieldNames }),
                    ]),
                    d_1.v('btn', {
                        classes: bs.btn + " " + bs.btnPrimary,
                        onclick: function () {
                            applyQuery(_this.query);
                            _this.openDialog = false;
                            _this.invalidate();
                        }
                    }, ['Apply query'])
                ]),
                d_1.v('button', {
                    classes: bs.btn + " " + bs.btnPrimary,
                    onclick: function () {
                        _this.openDialog = true;
                        _this.invalidate();
                    }
                }, ['Edit query'])
            ]);
        };
        return QueryEditorModal;
    }(WidgetBase_1.default));
    exports.default = QueryEditorModal;
});
//# sourceMappingURL=QueryEditorModal.js.map